/*{{{}}}*/
/*{{{  Machine characteristics*/
#define CHAR_METRICS		1,1,0
#define SHORT_METRICS		2,2,0
#define INT_METRICS		4,4,0
#define FLOAT_METRICS		4,4,1
#define DOUBLE_METRICS		8,4,0
#define POINTER_METRICS		4,4,0
#define	STRUCT_ALIGN		4
#define LITTLE_ENDIAN		1
#define JUMP_ON_RETURN          0
#define NODAG                   1
/*}}}  */

/*{{{  Env*/
typedef int Env;
/*}}}  */
/*{{{  Genorder*/
typedef enum
{
  NORMAL, TEMP, SWAP_REV, NORMAL_0, NORMAL_0REV, TEMP_0, TEMP_0SWAPREV,
  TEMP_0SWAP
} Genorder;
/*}}}  */
/*{{{  Xnode*/
typedef struct
{
#ifdef SYMDEBUG
  int id;                     /* node identification number */
#endif
  unsigned ioper:1;           /* is integer operator */
  unsigned uoper:1;           /* is unsigned operator */
  unsigned foper:1;           /* is floating point operator */
  unsigned need_result:4;     /* needs result storage */
  unsigned need_temp:4;       /* needs temp storage */
  Genorder genorder;          /* order of subtree code generation */
  Symbol tree_result;         /* tmp symbol to store result of node in */
  Symbol temp;                /* tmp symbol needed for conversions */
  Node top;                   /* top node */
} Xnode;
/*}}}  */
/*{{{  Xsymbol*/
typedef struct 
{
  char *name;		/* name for back end */
  int offset;		/* locals: frame offset, globals: offset value to symbol */
#if 0
  unsigned char type;	/* float or double for fpu TEMP */
#endif
} Xsymbol;
/*}}}  */

#define export(p)
#define import(p)
#define progend(x)

#define stabblock(a,b,c)
#define stabfend(a,b)
#define stabinit(a,b,c)
#define stabsym(a)
#define stabtype(a)
