/* #includes */ /*{{{C}}}*//*{{{*/
#include "c.h"
/*}}}*/
/* #defines */ /*{{{*/
#define typecode(p) (optype(p->op) == U ? I : optype(p->op) == B ? P : optype(p->op))
#define words(n) ((n)/4)
#define bytes(n) ((n)*4)
/*}}}*/

/* types */ /*{{{*/
/* Objtag */ /*{{{*/
typedef enum
{
  /* Do not change! */
  Obj_LABEL=0, Obj_CODE=1, Obj_EQU=2, Obj_ENDEQU=3, Obj_SYMBOL=4,
  Obj_NUMBER=5, Obj_ESUB=6, Obj_EADD=7, Obj_EMULT=8, Obj_EDIV=9,
  Obj_ENEGATE=10, Obj_AJW=11, Obj_ADC=12, Obj_ALIGN=13, Obj_LDC=14,
  Obj_LDLP=15, Obj_LDNL=16, Obj_LDNLP=17, Obj_LDL=18, Obj_CJ=19,
  Obj_CALL=20, Obj_D8=21, Obj_D16=22, Obj_D32=23, Obj_DS=24, Obj_EQC=25,
  Obj_STL=26, Obj_STNL=27, Obj_JUMP=28, Obj_PFIX=29, Obj_NFIX=30,
  Obj_LDPI=31, Obj_LEND=32, Obj_RELOCATE=33,

  /* Additional instructions, these are fine to change */
  Obj_NOT, Obj_LB, Obj_ADD, Obj_BSUB, Obj_AND, Obj_OR, Obj_XOR, Obj_DIV,
  Obj_SHL, Obj_REM, Obj_MUL, Obj_PROD, Obj_SHR, Obj_SUB, Obj_DIFF, Obj_LDIFF,
  Obj_SB, Obj_RET, Obj_GCALL, Obj_REV, Obj_GT, Obj_XWORD,
  Obj_LDIV, Obj_MOVE, Obj_WSUB, Obj_DSUB, Obj_T212, Obj_T222, Obj_T225,
  Obj_T400, Obj_T414, Obj_T425, Obj_T426, Obj_T800, Obj_T801, Obj_T805,
  Obj_FPLDNLSN, Obj_FPSTNLSN, Obj_FPLDNLDB, Obj_FPSTNLDB, Obj_FPDBSTNLI32, Obj_FPSNSTNLI32,
  Obj_FPLDZEROSN, Obj_FPLDZERODB, Obj_FPREV, Obj_FPADDSN, Obj_FPADDDB, 
  Obj_FPSUBSN, Obj_FPSUBDB, Obj_FPMULSN, Obj_FPMULDB, Obj_FPDIVSN, Obj_FPDIVDB,
  Obj_FPEQSN, Obj_FPEQDB, Obj_FPGTSN, Obj_FPGTDB, Obj_FPI32TOR64, Obj_FPI32TOR32,
  Obj_FPUR32TOR64, Obj_FPUR64TOR32, Obj_FPLDNLADDSN, Obj_FPLDNLADDDB,
  Obj_FPLDNLMULSN, Obj_FPLDNLMULDB, Obj_FPINT, Obj_FPUMULBY2
} Objtag;
/*}}}*/
/* Xopcode */ /*{{{*/
typedef enum
{
  FINDIR=(64<<4),
  FINDIRI=(64<<4)+I,
  FINDIRP=(64<<4)+P,
  LINDIR=(65<<4),
  LINDIRI=(65<<4)+I,
  LINDIRP=(65<<4)+P,
  CADD=(66<<4),
  CADDI=(66<<4)+I,
  CADDP=(66<<4)+P,
  GJUMP=(67<<4),
  GJUMPV=(67<<4)+V,
  FASGN=(68<<4),
  FASGNI=(68<<4)+I,
  FASGNP=(68<<4)+P,
  LASGN=(69<<4),
  LASGNI=(69<<4)+I,
  LASGNP=(69<<4)+P,
  GCALL=(70<<4),
  GCALLI=(70<<4)+I,
  GCALLF=(70<<4)+F,
  GCALLD=(70<<4)+D,
  GCALLV=(70<<4)+V,
  CEQ=(71<<4),
  CEQI=(71<<4)+I,
  CNEI=(72<<4)+I,
  GARG=(73<<4),
  GARGI=(73<<4)+I,
  GARGP=(73<<4)+P,
  WADD=(74<<4),
  WADDP=(74<<4)+P,
  DADD=(75<<4),
  DADDP=(75<<4)+P,
  CASGN=(76<<4),
  CASGNI=(76<<4)+I,
  CASGNP=(76<<4)+P,
  CINDIR=(77<<4),
  CINDIRI=(77<<4)+I,
  CINDIRP=(77<<4)+P,
  INDIRADD=(78<<4),
  INDIRADDF=(78<<4)+F,
  INDIRADDD=(78<<4)+D,
  INDIRMUL=(79<<4),
  INDIRMULF=(79<<4)+F,
  INDIRMULD=(79<<4)+D,
  ALINDIRS=(80<<4)+S,
  NLINDIRS=(81<<4)+S,
  CVFI=CVF+I,
  CVIF=CVI+F,
  MULD2=(82<<4)+D,
} Xopcode;
/*}}}*/
/* Argstate */ /*{{{*/
typedef enum { NOARGSYET, FINEARGS, MEANARGS } Argstate;
/*}}}*/
/* Templist */ /*{{{*/
typedef struct Templist
{
  Symbol temp;
  struct Templist *next;
} Templist;
/*}}}*/
/*}}}*/
/* variables */ /*{{{*/
static int maxoffset;           /* maximum value of offset */
static int offset;              /* current frame offset */
static int argoffset;           /* current ARG offset */
static Node lastarg=(Node)0, secondlastarg=(Node)0, thirdlastarg=(Node)0;
static Argstate state=NOARGSYET;/* no arguments for call seen yet */
static Objtag chip;             /* which transputer to generate code for */
static void (*emittoken_s)(Objtag t, char *s);
static void (*emittoken_i)(Objtag t, int i);
static void (*emittoken)(Objtag t);
static int begin;               /* no nodes from this tree generated yet */
static int hasfpu,nofpuerr=0;   /* only cry once about missing fpu */
static Templist *ilist;
static wptrcheck=0;
/*}}}*/

#ifdef SYMDEBUG
/* symname       -- print prefix, p's name, declaration source coordinate, suffix */ /*{{{*/
static void symname(Symbol p)
{
  if (p) print("%s@%w.%d", p->name, &p->src, p->src.x);
  else print("0");
}
/*}}}*/
/* sym           -- print symbol table entry for p, followed by str */ /*{{{*/
static void sym(char *kind, Symbol p, char *str)
{
        assert(kind);
        if (glevel > 2)
        {
          print("%s ", kind);
          symname(p);
        }
        else print("%s %s", kind, p->name);
        if (p->name != p->x.name) print(" (%s)", p->x.name);
        print(" type=%t class=%k scope=", p->type, p->sclass);
        switch (p->scope)
        {
        case CONSTANTS: print("CONSTANTS"); break;
        case LABELS:    print("LABELS");    break;
        case GLOBAL:    print("GLOBAL");    break;
        case PARAM:     print("PARAM");     break;
        case LOCAL:     print("LOCAL");     break;
        default:
                if (p->scope > LOCAL) print("LOCAL+%d", p->scope - LOCAL);
                else print("%d", p->scope);
        }
        if (p->scope >= PARAM && p->sclass != STATIC) print(" offset=%d ref=%d", p->x.offset, p->ref);
        if (glevel > 2)
        {
                print(" up=");
                symname(p->up);
        }
        if (str) print(str);
}
/*}}}*/
/* genordertype  -- return Genorder as string */ /*{{{*/
static char *genordertype(Node p)
{
  switch(p->x.genorder)
  {
    case NORMAL:        return "NORMAL       ";
    case TEMP:          return "TEMP         ";
    case SWAP_REV:      return "SWAP_REV     ";
    case NORMAL_0:      return "NORMAL_0     ";
    case NORMAL_0REV:   return "NORMAL_0REV  ";
    case TEMP_0:        return "TEMP_0       ";
    case TEMP_0SWAPREV: return "TEMP_0SWAPREV";
    case TEMP_0SWAP:    return "TEMP_0SWAP   ";
    default:            assert(0);
  }
}
/*}}}*/
/* xopname       -- return operator as string */ /*{{{*/
static char *xopname(Opcode op)
{
  switch (op)
  {
    case FINDIRI:   return "FINDIRI";
    case FINDIRP:   return "FINDIRP";
    case LINDIRI:   return "LINDIRI";
    case LINDIRP:   return "LINDIRP";
    case CADDI:     return "CADDI";
    case CADDP:     return "CADDP";
    case GJUMPV:    return "GJUMPV";
    case GCALLV:    return "GCALLV";
    case GCALLI:    return "GCALLI";
    case GCALLF:    return "GCALLF";
    case GCALLD:    return "GCALLD";
    case FASGNI:    return "FASGNI";
    case FASGNP:    return "FASGNP";
    case LASGNI:    return "LASGNI";
    case LASGNP:    return "LASGNP";
    case CEQI:      return "CEQI";
    case CNEI:      return "CNEI";
    case GARGI:     return "GARGI";
    case GARGP:     return "GARPG";
    case WADDP:     return "WADDP";
    case DADDP:     return "DADDP";
    case CASGNI:    return "CASGNI";
    case CASGNP:    return "CASGNP";
    case CINDIRI:   return "CINDIRI";
    case CINDIRP:   return "CINDIRP";
    case INDIRADDF: return "INDIRADDF";
    case INDIRADDD: return "INDIRADDD";
    case INDIRMULF: return "INDIRMULF";
    case INDIRMULD: return "INDIRMULD";
    case ALINDIRS:  return "ALINDIRS";
    case NLINDIRS:  return "NLINDIRS";
    case CVFI:      return "CVFI";
    case CVIF:      return "CVIF";
    case MULD2:     return "MULD2";
    default:        return (opname(op));
  }
}
/*}}}*/
#endif
/* checkfpu      -- check fpu code creation is ok */ /*{{{*/
void checkfpu(void)
{
  /*
  if (!hasfpu && !nofpuerr && (nofpuerr=1)) error("no floating point support for this processor");
  */
}
/*}}}*/
/* commutes      -- is opcode commutative? */ /*{{{*/
static int commutes(Opcode op)
{
  switch (generic(op))
  {
    case ADD:
    case BAND:
    case BOR:
    case BXOR:
    case MUL:
    case EQ:
    case NE:    return 1;
    default:    return 0;
  }
}
/*}}}*/
/* depth         -- compute integer stack depth of tree */ /*{{{*/
static unsigned int depth(Node p, Node top)
{
  if (p->x.top!=top) return 1;
  /* first check if this is an emulated fpu instruction */ /*{{{*/
  if (!hasfpu && p->x.foper) return 3;
  switch (p->op)
  {
    case CVFI:
    case CVIF:
    case CVDI:
    case CVID:  
    case CNSTF:
    case CNSTD:  return 3;
  }
  /*}}}*/
  /* now check for opcode dependent depth */ /*{{{*/
  switch (p->op)
  {
    case CALLI:
    case CALLF:
    case CALLD:
    case CALLB:
    case CALLV:  
    case GCALLI:
    case GCALLF:
    case GCALLD:
    case GCALLV:
    case INDIRS:
    case ASGNS:  return 3;
    case CVCI:
    case CVUC:
    case CVIC:
    case CVSI:
    case CVUS:
    case CVIS:
    case CVFI:
    case CVIF:
    case CVDI:
    case CVID:
    {
      int d;

      assert(p->kids[0]!=(Node)0);
      d=depth(p->kids[0],top);
      return (d>2 ? d : 2);
    }
    case CNSTF:
    case CNSTD:  return 0;
    case ALINDIRS:
    case NLINDIRS: return 2;
  }
  /*}}}*/
  if (p->x.ioper) /* depth of integer operand */ /*{{{*/
  {
    unsigned int d1=depth(p->kids[0], top), d2=depth(p->kids[1], top);

    assert(p->kids[0]!=(Node)0);
    assert(p->kids[1]!=(Node)0);
    return(d1==d2 ? d1+1 : (d1 < d2 ? d2 : d1));
  }
  /*}}}*/
  else if (p->x.uoper) /* depth of long/unsigned operand */ /*{{{*/
  {
    assert(p->kids[0]!=(Node)0);
    assert(p->kids[1]!=(Node)0);
    return(3);
  }
  /*}}}*/
  else if (p->x.foper) /* depth of floating operand */ /*{{{*/
  {
    unsigned int d1=depth(p->kids[0], top), d2=depth(p->kids[1], top);

    assert(p->kids[0]!=(Node)0);
    assert(p->kids[1]!=(Node)0);
    return(d1<d2 ? d2 : d1);
  }
  /*}}}*/
  if (p->kids[0]) return(depth(p->kids[0],top));
  assert(p->kids[1]==(Node)0);
  return 1;
}
/*}}}*/
/* fdepth        -- compute fp stack depth of tree */ /*{{{*/
static unsigned int fdepth(Node p, Node top)
{
  unsigned int d1,d2;

  if (p->x.top!=top) return 1;
  if (generic(p->op)==CALL || generic(p->op)==GCALL) return (3);
  if (p->x.foper)
  {
    d1=fdepth(p->kids[0], top);
    d2=(generic(p->op)==INDIRADD || generic(p->op)==INDIRMUL ? 1 : fdepth(p->kids[1], top));
    return(d1==d2 ? d1+1 : (d1 < d2 ? d2 : d1));
  }
  if (p->kids[0]) return((p->op==CVIF || p->op==CVID || p->op==INDIRF || p->op==INDIRD)+fdepth(p->kids[0],top));
  if (p->kids[1]) return(fdepth(p->kids[1],top));
  return(p->op==CNSTF || p->op==CNSTD);
}
/*}}}*/
/* useautotemp   -- use a new temporary */ /*{{{*/
static Symbol useautotemp(int t)
{
  if (ilist!=(Templist*)0 && t==I)
  {
    Symbol t;

    t=ilist->temp;
    ilist=ilist->next;
    return t;
  }
  else return(newtemp(AUTO,t));
}
/*}}}*/
/* relautotemp   -- release a temporary */ /*{{{*/
static void relautotemp(Symbol temp)
{
  Templist *x;

  if (temp->type->op!=INT) return;
  x=ilist;
  ilist=(Templist*)alloc(sizeof(Templist));
  ilist->temp=temp;
  ilist->next=x;
}
/*}}}*/
/* initautotemp  -- initialise list of free temporaries */ /*{{{*/
static void initautotemp(void)
{
  ilist=(Templist*)0;
}
/*}}}*/
/* attrtree      -- attribute tree */ /*{{{*/
static int attrtree(Node p, int n, Node top)
{
  if (p && p->x.top==(Node)0)
  {
#ifdef SYMDEBUG
    p->x.id=n;
#endif
    ++n;
    p->x.top=top;
    p->x.tree_result=(Symbol)0;
    p->x.temp=(Symbol)0;
    p->x.need_result=0;
    p->x.need_temp=0;
    if (p->op==CNSTD) 
    {
      Value v;
      Symbol c;

      p->op=INDIRD;
      c=newconst(p->syms[0]->u.c.v,D);
      p->syms[0]=(Symbol)0;
      if (c->u.c.loc == 0) c->u.c.loc = genident(STATIC, c->type, GLOBAL);
      p->kids[0]=newnode(ADDRGP,(Node)0,(Node)0,c->u.c.loc);
    }
    /* swap kids on ASGN[CSIPFDB], LT[IUFD], GE[IUFD] */ /*{{{*/
    if (generic(p->op)==ASGN || p->op==LTI || p->op==LTU || p->op==LTF || p->op==LTD || p->op==GEI || p->op==GEU || p->op==GEF || p->op==GED)
    {
      Node tmp;

      tmp = p->kids[0]; p->kids[0]=p->kids[1]; p->kids[1]=tmp;
    }
    /*}}}*/
    /* optimize code with converting opcodes to extended opcodes */ /*{{{*/
    switch (p->op)
    {
      /* convert INDIR[IP] of ADDR[FL] or ADDP */ /*{{{*/
      case INDIRI:
      case INDIRP:
      {
        switch (p->kids[0]->op)
        {
          /* ADDRFP */ /*{{{*/
          case ADDRFP:
          {
            p->op=FINDIR+optype(p->op);
            p->syms[0]=p->kids[0]->syms[0];
            p->kids[0]=(Node)0;

            break;
          }
          /*}}}*/
          /* ADDRLP */ /*{{{*/
          case ADDRLP:
          {
            p->op=LINDIR+optype(p->op);
            p->syms[0]=p->kids[0]->syms[0];
            p->kids[0]=(Node)0;

            break;
          }
          /*}}}*/
          /* ADDP */ /*{{{*/
          case ADDP:
          {
            if (p->kids[0]->kids[0]->op==CNSTI)
            {
              p->op=CINDIR+optype(p->op);
              p->syms[0]=p->kids[0]->kids[0]->syms[0];
              p->kids[0]=p->kids[0]->kids[1];
            }
            else if (p->kids[0]->kids[1]->op==CNSTI)
            {
              p->op=CINDIR+optype(p->op);
              p->syms[0]=p->kids[0]->kids[1]->syms[0];
              p->kids[0]=p->kids[0]->kids[0];
            }
            break;
          }
          /*}}}*/
          default: break;
        }
        break;
      }
      /*}}}*/
      /* convert ASGN[IP] of ADDR[FL] or ADDP */ /*{{{*/
      case ASGNI:
      case ASGNP:
      {
        switch (p->kids[1]->op)
        {
          /* ADDRFP */ /*{{{*/
          case ADDRFP:
          {
            p->op=FASGN+optype(p->op);
            p->syms[0]=p->kids[1]->syms[0]; p->syms[1]=p->kids[1]->syms[1];
            p->kids[1]->count--;
            p->kids[1]=(Node)0;
            break;
          }
          /*}}}*/
          /* ADDRLP */ /*{{{*/
          case ADDRLP:
          {
            p->op=LASGN+optype(p->op);
            p->syms[0]=p->kids[1]->syms[0]; p->syms[1]=p->kids[1]->syms[1];
            p->kids[1]->count--;
            p->kids[1]=(Node)0;
            break;
          }
          /*}}}*/
          /* ADDP */ /*{{{*/
          case ADDP:
          {
            if (p->kids[1]->kids[0]->op==CNSTI)
            {
              p->op=CASGN+optype(p->op);
              p->syms[2]=p->kids[1]->kids[0]->syms[0];
              p->kids[1]->count--;
              p->kids[1]=p->kids[1]->kids[1];
            }
            else if (p->kids[1]->kids[1]->op==CNSTI)
            {
              p->op=CASGN+optype(p->op);
              p->syms[2]=p->kids[1]->kids[1]->syms[0];
              p->kids[1]->count--;
              p->kids[1]=p->kids[1]->kids[0];
            }
            break;
          }
          /*}}}*/
          default: break;
        }
        break;
      }
      /*}}}*/
      /* convert ADDI with one child being a constant */ /*{{{*/
      case ADDI:
      if (generic(p->kids[0]->op)==CNST) /* child 0 is CNST */ /*{{{*/
      {
        p->syms[0]=p->kids[0]->syms[0];
        p->kids[0]->count--;
        p->kids[0]=(Node)0;
        p->op=CADDI;
      }
      /*}}}*/
      else if (generic(p->kids[1]->op)==CNST) /* child 1 is CNST */ /*{{{*/
      {
        p->syms[0]=p->kids[1]->syms[0];
        p->kids[1]->count--;
        p->kids[1]=(Node)0;
        p->op=CADDI;
      }
      /*}}}*/
      break;
      /*}}}*/
      /* convert SUBI with right child being a constant */ /*{{{*/
      case SUBI:
      if (generic(p->kids[1]->op)==CNST)
      /* child 1 is CNST */ /*{{{*/
      {
        Value v=p->kids[1]->syms[0]->u.c.v;

        v.i=-v.i;
        p->syms[0]=newconst(v,typecode(p));
        p->kids[1]->count--;
        p->kids[1]=(Node)0;
        p->op=CADDI;
      }
      /*}}}*/
      break;
      /*}}}*/
      /* convert ADDP with one child being a constant or with LSHI(2) */ /*{{{*/
      case ADDP:
      if (generic(p->kids[0]->op)==CNST)
      /* child 0 is CNST */ /*{{{*/
      {
        p->syms[0]=p->kids[0]->syms[0];
        p->op=CADDI;
        p->kids[0]->count--;
        p->kids[0]=(Node)0;
      }
      /*}}}*/
      else if (generic(p->kids[1]->op)==CNST)
      /* child 1 is CNST */ /*{{{*/
      {
        p->syms[0]=p->kids[1]->syms[0];
        p->op=CADDI;
        p->kids[1]->count--;
        p->kids[1]=(Node)0;
      }
      /*}}}*/
      else if (p->kids[0]->op==LSHI)
      /* child 0 may be word subscript */ /*{{{*/
      {
        if (p->kids[0]->kids[1]->op==CNSTI)
        {
          if (p->kids[0]->kids[1]->syms[0]->u.c.v.u==2)
          {
            p->op=WADD+optype(p->op);
            p->kids[0]->count--;
            p->kids[0]=p->kids[0]->kids[0];
          }
          else if ((chip==Obj_T400 || chip==Obj_T425 || chip==Obj_T426 || chip==Obj_T800 || chip==Obj_T801 || chip==Obj_T805) && (p->kids[0]->kids[1]->syms[0]->u.c.v.u==3))
          {
            p->op=DADD+optype(p->op);
            p->kids[0]->count--;
            p->kids[0]=p->kids[0]->kids[0];
          }
        }
      }
      /*}}}*/
      break;
      /*}}}*/
      /* convert SUBP with right child being a constant */ /*{{{*/
      case SUBP:
      if (generic(p->kids[1]->op)==CNST)
      /* child 1 is CNST */ /*{{{*/
      {
        Value v=p->kids[1]->syms[0]->u.c.v;

        v.i=-v.i;
        p->syms[0]=newconst(v,typecode(p));
        p->kids[1]->count--;
        p->kids[1]=(Node)0;
        p->op=CADDI;
      }
      /*}}}*/
      break;
      /*}}}*/
      /* convert EQI with one child being a constant */ /*{{{*/
      case EQI:
      if (generic(p->kids[0]->op)==CNST)
      /* child 0 is CNST */ /*{{{*/
      {
        p->syms[1]=p->kids[0]->syms[0];
        p->kids[0]->count--;
        p->kids[0]=p->kids[1];
        p->kids[1]=(Node)0;
        p->op=CEQI;
      }
      /*}}}*/
      else if (generic(p->kids[1]->op)==CNST)
      /* child 1 is CNST */ /*{{{*/
      {
        p->syms[1]=p->kids[1]->syms[0];
        p->kids[1]->count--;
        p->kids[1]=(Node)0;
        p->op=CEQI;
      }
      /*}}}*/
      break;
      /*}}}*/
      /* convert NEI with one child being a constant */ /*{{{*/
      case NEI:
      if (generic(p->kids[0]->op)==CNST)
      /* child 0 is CNST */ /*{{{*/
      {
        p->syms[1]=p->kids[0]->syms[0];
        p->kids[0]->count--;
        p->kids[0]=(Node)0;
        p->op=CNEI;
      }
      /*}}}*/
      else if (generic(p->kids[1]->op)==CNST)
      /* child 1 is CNST */ /*{{{*/
      {
        p->syms[1]=p->kids[1]->syms[0];
        p->kids[1]->count--;
        p->kids[1]=(Node)0;
        p->op=CNEI;
      }
      /*}}}*/
      break;
      /*}}}*/
      /* convert JUMPV of ADDRGP */ /*{{{*/
      case JUMPV:
      {
        if (p->kids[0]->op==ADDRGP)
        {
          p->op=GJUMPV;
          p->syms[0]=p->kids[0]->syms[0];
          p->kids[0]->count--;
          p->kids[0]=(Node)0;
        }
        break;
      }
      /*}}}*/
      /* convert CALLB */ /*{{{*/
      case CALLB:
      {
        Node nextp=newnode(CALLV, p->kids[0], (Node)0, p->syms[0]);
        Node plink=p->link;
        Xnode x=p->x;

        *p=*newnode(ARGP, p->kids[1], (Node)0, (Symbol)0);
        p->x=x;
        p->link=nextp;
        nextp->link=plink;
        break;
      }
      /*}}}*/
      /* convert CVDF of CVID */ /*{{{*/
      case CVDF:
      {
        if (p->kids[0]->op==CVID)
        {
          p->op=CVIF;
          p->kids[0]=p->kids[0]->kids[0];
        }
        break;
      }
      /*}}}*/
      /* convert CVDI of CVFD */ /*{{{*/
      case CVDI:
      {
        if (p->kids[0]->op==CVFD)
        {
          p->op=CVFI;
          p->kids[0]=p->kids[0]->kids[0];
        }
        break;
      }
      /*}}}*/
      /* convert CVUC of CVIU of CVCI of anything to anything */ /*{{{*/
      case CVUC:
      {
        if (p->kids[0]->op==CVIU && p->kids[0]->kids[0]->op==CVCI)
        {
          Xnode x=p->x;

          *p=*(p->kids[0]->kids[0]->kids[0]);
          p->x=x;
        }
        break;
      }
      /*}}}*/
      /* convert CVUS of CVIU of CVSI of anything to anything */ /*{{{*/
      case CVUS:
      {
        if (p->kids[0]->op==CVIU && p->kids[0]->kids[0]->op==CVSI)
        {
          Xnode x=p->x;

          *p=*(p->kids[0]->kids[0]->kids[0]);
          p->x=x;
        }
        break;
      }
      /*}}}*/
      /* convert ADDF of INDIRF */ /*{{{*/
      case ADDF:
      {
        if (p->kids[1]->op==INDIRF)
        {
          p->op=INDIRADDF;
          p->kids[1]=p->kids[1]->kids[0];
        }
        break;
      }
      /*}}}*/
      /* convert ADDD of INDIRD */ /*{{{*/
      case ADDD:
      {
        if (p->kids[1]->op==INDIRD)
        {
          p->op=INDIRADDD;
          p->kids[1]=p->kids[1]->kids[0];
        }
        break;
      }
      /*}}}*/
      /* convert MULF of INDIRF */ /*{{{*/
      case MULF:
      {
        if (p->kids[1]->op==INDIRF)
        {
          p->op=INDIRMULF;
          p->kids[1]=p->kids[1]->kids[0];
        }
        break;
      }
      /*}}}*/
      /* convert MULD of CNSTD 2.0 or INDIRD */ /*{{{*/
      case MULD:
      {
	extern int is2(Symbol s);

        if (hasfpu && p->kids[0]->op==CNSTD)
        {
          p->op=MULD2;
          p->kids[0]=p->kids[1];
          p->kids[1]=(Node)0;
        }
        else if (hasfpu && p->kids[1]->op==CNSTD)
        {
          p->op=MULD2;
          p->kids[1]=(Node)0;
        }
        else if (p->kids[1]->op==INDIRD)
        {
          p->op=INDIRMULD;
          p->kids[1]=p->kids[1]->kids[0];
        }
        break;
      }
      /*}}}*/
      /* convert INDIRS of ADDRLP */ /*{{{*/
      case INDIRS:
      {
        if (p->kids[0]->op==ADDRLP)
        {
          p->op=(p->kids[0]->syms[0]->x.offset)&3 ? NLINDIRS : ALINDIRS;
          p->syms[0]=p->kids[0]->syms[0];
          p->kids[0]=(Node)0;
        }
        break;
      }
      /*}}}*/
      default: break;
    }
    /*}}}*/
    /* if it is p->x.uoper */ /*{{{*/
    if (p->op==DIVU || p->op==MODU || p->op==GTU || p->op==GEU || p->op==LTU || p->op==LEU) { p->x.uoper=1; p->x.ioper=p->x.foper=0; }
    /*}}}*/
    else
    /* it is p->x.[fi]ioper or no operator */ /*{{{*/
    switch (generic(p->op))
    {
      case ADD:
      case WADD:
      case DADD:
      case BAND:
      case BOR:
      case BXOR:
      case DIV:
      case LSH:
      case MOD:
      case MUL:
      case RSH:
      case SUB:
      case ASGN:
      case CASGN:
      case EQ:
      case GE:
      case GT:
      case LE:
      case LT:
      case NE:
      case INDIRADD:
      case INDIRMUL:
      {
        if (optype(p->op)==F || optype(p->op)==D) { p->x.foper=1; p->x.uoper=p->x.ioper=0; }
        else { p->x.ioper=1; p->x.uoper=p->x.foper=0; }
        break;
      }
      default:   p->x.ioper=p->x.uoper=p->x.foper=0; assert(p->kids[0]==(Node)0 || p->kids[1]==(Node)0);
    }
    /*}}}*/
    assert(p->count<=1);
    if (p->op==INDIRS || p->op==CVID || p->op==CVIF || p->op==CVDI || p->op==CVFI) p->x.need_temp=I;
    n=attrtree(p->kids[0], n, top);
    n=attrtree(p->kids[1], n, top);
  }
  return n;
}
/*}}}*/
/* reordertree   -- reorder tree nodes according to depth */ /*{{{*/
static void reordertree(Node p, Node top)
{
  if (p->x.ioper || p->x.foper)
  /* integer or floating point operator code generation */ /*{{{*/
  {
    unsigned int d1,d2;

    assert(p->kids[0]); 
    assert(p->kids[1]);
    if (p->x.ioper) { d1=depth(p->kids[0],top); d2=depth(p->kids[1],top); }
    else { d1=fdepth(p->kids[0],top); d2=fdepth(p->kids[1],top); }

    if (p->op==ASGNS)
    {
      p->x.genorder=NORMAL;
      p->kids[0]->x.need_result=I;
    }
    else if (d2 > d1)
    {
      if (d1 > 2)
      {
        Node foo;

        p->x.genorder=TEMP;
        if (p->kids[1]->x.need_result==0) p->kids[1]->x.need_result=typecode(p);
        foo=p->kids[1];
        p->kids[1]=p->kids[0];
        p->kids[0]=foo;
      }
      else if (d2<3 && p==top ) p->x.genorder=NORMAL;
      else
      { 
        Node foo;

        p->x.genorder=(commutes(p->op) ? NORMAL : SWAP_REV);
        foo=p->kids[1];
        p->kids[1]=p->kids[0];
        p->kids[0]=foo;
      }
    }
    else if (d2<3) p->x.genorder=NORMAL;
    else
    {   
      Node foo;

      p->x.genorder=TEMP;
      if (p->kids[1]->x.need_result==0) p->kids[1]->x.need_result=typecode(p);
      foo=p->kids[1];
      p->kids[1]=p->kids[0];
      p->kids[0]=foo;
    }
  }
  /*}}}*/
  else if (p->x.uoper)
  /* long/unsigned integer operator code generation */ /*{{{*/
  {
    unsigned int d1=depth(p->kids[0],top), d2=depth(p->kids[1],top);

    assert(p->kids[0]); 
    assert(p->kids[1]);
    if (d1<=2 && d2==1) p->x.genorder=NORMAL_0;
    else if (d1>=3 && d2==1) p->x.genorder=NORMAL_0REV;
    else if (d1<=2)
    {
      Node foo;

      p->x.genorder=TEMP_0;
      if (p->kids[1]->x.need_result==0) p->kids[1]->x.need_result=typecode(p);
      foo=p->kids[1];
      p->kids[1]=p->kids[0];
      p->kids[0]=foo;
    }
    else if (d1>=3 && d2==2)
    {
      p->x.genorder=TEMP_0SWAPREV;
      if (p->kids[0]->x.need_result==0) p->kids[0]->x.need_result=typecode(p);
    }
    else
    {
      Node foo;

      p->x.genorder=TEMP_0SWAP;
      if (p->kids[1]->x.need_result==0) p->kids[1]->x.need_result=typecode(p);
      foo=p->kids[1];
      p->kids[1]=p->kids[0];
      p->kids[0]=foo;
    }
  }
  /*}}}*/
  else
  /* no operator */ /*{{{*/
  {
    assert(p->kids[1]==(Node)0);
    p->x.genorder=NORMAL;
  }
  /*}}}*/

  if (p->kids[0])
  /* process child 0 */ /*{{{*/
  {
    if (p->kids[0]->x.top!=top)
    /* foreign child */ /*{{{*/
    {
      if (p->kids[0]->x.need_result==0 && !(p->kids[0]->link==top && begin))
      p->kids[0]->x.need_result=typecode(p->kids[0]);
      begin=0;
    }
    /*}}}*/
    else reordertree(p->kids[0],top);
  }
  /*}}}*/
  if (p->kids[1])
  /* process child 1 */ /*{{{*/
  {
    if (p->kids[1]->x.top!=top)
    /* foreign child */ /*{{{*/
    {
      if (p->kids[1]->x.need_result==0 && !(p->kids[1]->link==top && begin))
      p->kids[1]->x.need_result=typecode(p->kids[0]);
      begin=0;
    }
    /*}}}*/
    else reordertree(p->kids[1],top);
  }
  /*}}}*/
  begin=0;
}
/*}}}*/
/* populatetree  -- populate tree with temporaries as needed */ /*{{{*/
static void populatetree(Node p, Node top)
{
  if (p && p->x.top==top)
  {
    populatetree(p->kids[0],top);
    populatetree(p->kids[1],top);
    if (p->x.need_result) p->x.tree_result=useautotemp(p->x.need_result);
    if (p->x.need_temp) p->x.temp=useautotemp(p->x.need_temp);
    if (p->kids[0] && p->kids[0]->x.tree_result) relautotemp(p->kids[0]->x.tree_result);
    if (p->kids[1] && p->kids[1]->x.tree_result) relautotemp(p->kids[1]->x.tree_result);
    if (p->x.temp) relautotemp(p->x.temp);
  }
}
/*}}}*/
/* emitasm_s     -- emit a token with a symbol in assembler */ /*{{{*/
static void emitasm_s(Objtag t, char *s)
{
  switch (t)
  {
    case Obj_LABEL: print("%s\n",s); break;
    case Obj_CJ:    print(" cj %s\n",s); break;
    case Obj_CALL:  print(" call %s\n",s); break;
    case Obj_D32:   print(" reloc\n d32 %s\n",s); break;
    case Obj_JUMP:  print(" j %s\n",s); break;
    case Obj_LDPI:  print(" ldpi %s\n",s); break;
    default:        assert(0);
  }
}
/*}}}*/
/* emitasm_i     -- emit a token with a number in assembler */ /*{{{*/
static void emitasm_i(Objtag t, int i)
{
  switch (t)
  {
    case Obj_AJW:
    {
      if (!i) return;
      print(" ajw %d\n",i); 
      if (i<0 && wptrcheck) 
      {
        emitasm_i(Obj_LDC,i);
        print(" call ___wptrcheck\n");
      }  
      break;
    }  
    case Obj_ADC:   if (!i) return; print(" adc %d\n",i); break;
    case Obj_LDC:   
    {
      if (i==0x80000000)
      {
        print(" mint\n");
        return;
      }  
      else if (i==0x7fffffff)
      {
        print(" mint\n");
        print(" not\n");
        return;
      }
      else if (((unsigned)i)>=0x80000004U && ((unsigned)i)<=0x803ffffcU && !(i&3))
      { 
        print(" mint\n");
        print(" ldnlp %d\n",(i & 0x7fffffff)>>2);
      }
      else if (((unsigned)i)>=0x80000001U && ((unsigned)i)<=0x800fffffU)
      {
        print(" mint\n");
        print(" adc %d\n",i & 0x7fffffff);
      }
      else if (((unsigned)i)>=0x7fffc000U && ((unsigned)i)<=0x7ffffffbU && !((~i)&3))
      {
        print(" mint\n");
        print(" ldnlp %d\n",((~i) & 0x7fffffff)>>2);
        print(" not\n");
      }
      else if (((unsigned)i)>=0x7ffff000U && ((unsigned)i)<=0x7ffffffeU)
      {
        print(" mint\n");
        print(" adc %d\n",(~i) & 0x7fffffff);
        print(" not\n");
      }
      else print(" ldc %d\n",i); 
      break;
    }
    case Obj_LDLP:  print(" ldlp %d\n",i); break;
    case Obj_LDNL:  print(" ldnl %d\n",i); break;
    case Obj_LDL:   print(" ldl %d\n",i); break;
    case Obj_D8:    print(" d8 %d\n",i); break;
    case Obj_D16:   print(" d16 %d\n",i); break;
    case Obj_D32:   print(" d32 %d\n",i); break;
    case Obj_DS:    print(" ds %d\n",i); break;
    case Obj_EQC:   print(" eqc %d\n",i); break;
    case Obj_STL:   print(" stl %d\n",i); break;
    case Obj_STNL:  print(" stnl %d\n",i); break;
    default:        assert(0);
  }
}
/*}}}*/
/* emitasm       -- emit a token in assembler */ /*{{{*/
static void emitasm(Objtag t)
{
  switch (t)
  {
    case Obj_ALIGN:       print(" align\n"); break;
    case Obj_NOT:         print(" not\n"); break;
    case Obj_LB:          print(" lb\n"); break;
    case Obj_ADD:         print(" add\n"); break;
    case Obj_BSUB:        print(" bsub\n"); break;
    case Obj_AND:         print(" and\n"); break;
    case Obj_OR:          print(" or\n"); break;
    case Obj_XOR:         print(" xor\n"); break;
    case Obj_DIV:         print(" div\n"); break;
    case Obj_SHL:         print(" shl\n"); break;
    case Obj_REM:         print(" rem\n"); break;
    case Obj_MUL:         print(" mul\n"); break;
    case Obj_PROD:        print(" prod\n"); break;
    case Obj_SHR:         print(" shr\n"); break;
    case Obj_SUB:         print(" sub\n"); break;
    case Obj_DIFF:        print(" diff\n"); break;
    case Obj_LDIFF:       print(" ldiff\n"); break;
    case Obj_SB:          print(" sb\n"); break;
    case Obj_RET:         print(" ret\n"); break;
    case Obj_GCALL:       print(" gcall\n"); break;
    case Obj_REV:         print(" rev\n"); break;
    case Obj_GT:          print(" gt\n"); break;
    case Obj_XWORD:       print(" xword\n"); break;
    case Obj_LDIV:        print(" ldiv\n"); break;
    case Obj_MOVE:        print(" move\n"); break;
    case Obj_WSUB:        print(" wsub\n"); break;
    case Obj_DSUB:        print(" wsubdb\n"); break;
    case Obj_T400:        print(" t400\n"); break;
    case Obj_T414:        print(" t414\n"); break;
    case Obj_T425:        print(" t425\n"); break;
    case Obj_T800:        print(" t800\n"); break;
    case Obj_T801:        print(" t801\n"); break;
    case Obj_T805:        print(" t805\n"); break;
    case Obj_FPLDNLSN:    if (hasfpu) print(" fpldnlsn\n"); else print(" call fpldnlsn\n"); break;
    case Obj_FPSTNLSN:    if (hasfpu) print(" fpstnlsn\n"); else print(" call fpstnlsn\n"); break;
    case Obj_FPLDNLDB:    if (hasfpu) print(" fpldnldb\n"); else print(" call fpldnldb\n"); break;
    case Obj_FPSTNLDB:    if (hasfpu) print(" fpstnldb\n"); else print(" call fpstnldb\n"); break;
    case Obj_FPDBSTNLI32: if (hasfpu) print(" fpstnli32\n"); else print(" call fpdbstnli32"); break;
    case Obj_FPSNSTNLI32: if (hasfpu) print(" fpstnli32\n"); else print(" call fpsnstnli32"); break;
    case Obj_FPLDZEROSN:  if (hasfpu) print(" fpldzerosn\n"); else print(" call fpldzerosn\n"); break;
    case Obj_FPLDZERODB:  if (hasfpu) print(" fpldzerodb\n"); else print(" call fpldzerodb\n"); break;
    case Obj_FPREV:       if (hasfpu) print(" fprev\n"); else print(" call fprev\n"); break;
    case Obj_FPADDDB:     if (hasfpu) print(" fpadd\n"); else print(" call fpadddb\n"); break;
    case Obj_FPADDSN:     if (hasfpu) print(" fpadd\n"); else print(" call fpaddsn\n"); break;
    case Obj_FPSUBDB:     if (hasfpu) print(" fpsub\n"); else print(" call fpsubdb\n"); break;
    case Obj_FPSUBSN:     if (hasfpu) print(" fpsub\n"); else print(" call fpsubsn\n"); break;
    case Obj_FPMULSN:     if (hasfpu) print(" fpmul\n"); else print(" call fpmulsn\n"); break;
    case Obj_FPMULDB:     if (hasfpu) print(" fpmul\n"); else print(" call fpmuldb\n"); break;
    case Obj_FPDIVSN:     if (hasfpu) print(" fpdiv\n"); else print(" call fpdivsn\n"); break;
    case Obj_FPDIVDB:     if (hasfpu) print(" fpdiv\n"); else print(" call fpdivsn\n"); break;
    case Obj_FPEQSN:      if (hasfpu) print(" fpeq\n"); else print(" call fpeqsn\n"); break;
    case Obj_FPEQDB:      if (hasfpu) print(" fpeq\n"); else print(" call fpeqdb\n"); break;
    case Obj_FPGTSN:      if (hasfpu) print(" fpgt\n"); else print(" call fpgtsn\n"); break;
    case Obj_FPGTDB:      if (hasfpu) print(" fpgt\n"); else print(" call fpgtdb\n"); break;
    case Obj_FPUR32TOR64: if (hasfpu) print(" fpur32tor64\n"); else print(" call fpur32tor64\n"); break;
    case Obj_FPUR64TOR32: if (hasfpu) print(" fpur64tor32\n"); else print(" call fpur64tor32\n"); break;
    case Obj_FPI32TOR64:  if (hasfpu) print(" fpi32tor64\n"); else print(" call fpi32tor64\n"); break;
    case Obj_FPI32TOR32:  if (hasfpu) print(" fpi32tor32\n"); else print(" call fpi32tor32\n"); break;
    case Obj_FPLDNLADDSN: if (hasfpu) print(" fpldnladdsn\n"); else print(" call fpldnladdsn\n"); break;
    case Obj_FPLDNLADDDB: if (hasfpu) print(" fpldnladddb\n"); else print(" call fpldnladddb\n"); break;
    case Obj_FPLDNLMULSN: if (hasfpu) print(" fpldnlmulsn\n"); else print(" call fpldnlmulsn\n"); break;
    case Obj_FPLDNLMULDB: if (hasfpu) print(" fpldnlmuldb\n"); else print(" call fpldnlmuldb\n"); break;
    case Obj_FPINT:       if (hasfpu) print(" fpint\n"); else assert(0);break;
    case Obj_FPUMULBY2:   if (hasfpu) print(" fpumulby2\n"); else assert(0); break;
    default:              assert(0);
  }
}
/*}}}*/
/* emitobj_s     -- emit a token with a symbol in object format */ /*{{{*/
static void emitobj_s(Objtag t, char *s)
{
  switch (t)
  {
    case Obj_EQU:
    case Obj_SYMBOL:
    case Obj_LABEL:
    case Obj_CJ:
    case Obj_CALL:
    case Obj_JUMP:
    case Obj_LDPI:  outc(t); while (*s) outc(*s++); outc('\0'); break;
    case Obj_D32:   outc(Obj_RELOCATE); outc(Obj_D32); while (*s) outc(*s++); outc('\0'); break;
    case Obj_ALIGN: outc(Obj_ALIGN); break;
    default: assert(0);
  }
}
/*}}}*/
/* primarylen    -- determine length of nfix/pfix code for a primary instruction */ /*{{{*/
static int primarylen(unsigned long lval)
{
  int len;

  if (lval == 0) return 1;
  if (lval & 0x80000000L)
  /* negative numbers */ /*{{{*/
  {
    len = 2;
    if (((unsigned long) 0xFFFFFFFFL - lval) >= (unsigned long) 0x100L) len++;
    if (((unsigned long) 0xFFFFFFFFL - lval) >= (unsigned long) 0x1000L) len++;
    if (((unsigned long) 0xFFFFFFFFL - lval) >= (unsigned long) 0x10000L) len++;
    if (((unsigned long) 0xFFFFFFFFL - lval) >= (unsigned long) 0x100000L) len++;
    if (((unsigned long) 0xFFFFFFFFL - lval) >= (unsigned long) 0x1000000L) len++;
    if (((unsigned long) 0xFFFFFFFFL - lval) >= (unsigned long) 0x10000000L) len++;
  }
  /*}}}*/
  else
  /* positive numbers */ /*{{{*/
  {
    len = 1;
    if (lval >= (unsigned long) 0x10L) len++;
    if (lval >= (unsigned long) 0x100L) len++;
    if (lval >= (unsigned long) 0x1000L) len++;
    if (lval >= (unsigned long) 0x10000L) len++;
    if (lval >= (unsigned long) 0x100000L) len++;
    if (lval >= (unsigned long) 0x1000000L) len++;
    if (lval >= (unsigned long) 0x10000000L) len++;
  }
  /*}}}*/
  return (len);
}
/*}}}*/
/* genprimary    -- generate nfix/pfix code for a primary instruction */ /*{{{*/
static void genprimary(unsigned long lval, unsigned char instr)
{
  int  i;
  char cval;
  int sent, nval;

  if (lval > 0xFL)
  {
    sent = 0;
    nval = (lval > 0x7FFFFFFFL);

    for (i = 1; i < 8; i++)
    {
      cval = (char) ((lval & 0xF0000000L) >> 28);
      if (((cval != 0) && !nval) || sent || ((cval != 0xF) && nval))
      {
        if (nval && !sent) cval = (0x60 | (char) (~cval & 0xF));
        else cval = (0x20 | cval);
        outc(cval);
        sent = 1;
      }
      lval <<= 4;
    }
    if (nval && !sent) outc(0x60);
    outc(((unsigned char) ((lval & 0xF0000000L) >> 28))|instr);
  }
  else outc(((unsigned char) lval)|instr);
}
/*}}}*/
/* emitobj_i     -- emit a token with a number in object format */ /*{{{*/
static void emitobj_i(Objtag t, int i)
{
  /* variables */ /*{{{*/
  unsigned char instr;
  int gennot=0;
  /*}}}*/

  switch (t)
  {
    case Obj_AJW:    if (i==0) return; instr=0xb0; break;
    case Obj_ADC:    if (i==0) return; instr=0x80; break;
    case Obj_EQC:    instr=0xc0; break;
    case Obj_LDC:    
    {
      if (i==0x80000000)
      {
        outc(Obj_CODE); outc(2); outc(0x24); outc(0xf2);
        return;
      }  
      else if (i==0x7fffffff)
      {
        outc(Obj_CODE); outc(2); outc(0x24); outc(0xf2);
        outc(Obj_CODE); outc(2); outc(0x23); outc(0xf2);
        return;
      }
      else if (((unsigned)i)>=0x80000004U && ((unsigned)i)<=0x803ffffcU && !(i&3))
      { 
        outc(Obj_CODE); outc(2); outc(0x24); outc(0xf2);
        i=((i & 0x7fffffff)>>2);
        instr=0x50;
      }
      else if (((unsigned)i)>=0x80000001U && ((unsigned)i)<=0x800fffffU)
      {
        outc(Obj_CODE); outc(2); outc(0x24); outc(0xf2);
        i=(i & 0x7fffffff);
        instr=0x80;
      }
      else if (((unsigned)i)>=0x7fffc000U && ((unsigned)i)<=0x7ffffffbU && !((~i)&3))
      {
        outc(Obj_CODE); outc(2); outc(0x24); outc(0xf2);
        i=(((~i) & 0x7fffffff)>>2);
        instr=0x50;
        gennot=1;
      }
      else if (((unsigned)i)>=0x7ffff000U && ((unsigned)i)<=0x7ffffffeU)
      {
        outc(Obj_CODE); outc(2); outc(0x24); outc(0xf2);
        i=((~i) & 0x7fffffff);
        instr=0x80;
        gennot=1;
      }
      else 
      instr=0x40;
      break;
    }
    case Obj_LDLP:   instr=0x10; break;
    case Obj_LDNL:   instr=0x30; break;
    case Obj_LDL:    instr=0x70; break;
    case Obj_D8:     outc(Obj_CODE); outc(1); outc(i); return;
    case Obj_D16:    outc(Obj_CODE); outc(2); outc(i&0xff); outc((i>>8)&0xff); return;
    case Obj_D32:    outc(Obj_CODE); outc(4); outc(i&0xff); outc((i>>8)&0xff); outc((i>>16)&0xff); outc((i>>24)&0xff); return;
    case Obj_DS:     outc(Obj_DS); outc(i&0xff); outc((i>>8)&0xff); outc((i>>16)&0xff); outc((i>>24)&0xff); return;
    case Obj_NUMBER: outc(Obj_NUMBER); outc(i&0xff); outc((i>>8)&0xff); outc((i>>16)&0xff); outc((i>>24)&0xff); return;
    case Obj_STL:    instr=0xd0; break;
    case Obj_STNL:   instr=0xe0; break;
    default:         assert(0);
  }
  outc(Obj_CODE);
  outc(primarylen(i));
  genprimary(i,instr);
  if (gennot) { outc(Obj_CODE); outc(2); outc(0x23); outc(0xf2); }
  if (t==Obj_AJW && i<0 && wptrcheck)
  {
    emitobj_i(Obj_LDC,-i);
    emitobj_s(Obj_CALL,"___wptrcheck");
  }
}
/*}}}*/
/* emitobj       -- emit a token in object format */ /*{{{*/
static void emitobj(Objtag t)
{
  /* variables */ /*{{{*/
  unsigned char a,b,c,d;
  unsigned char len;
  /*}}}*/

  len=2;
  switch (t)
  {
    case Obj_ALIGN:
    case Obj_ENDEQU:
    case Obj_EADD:        outc(t); return;
    case Obj_NOT:         a=0x23; b=0xf2; break;
    case Obj_LB:          len=1; a=0xf1; break;
    case Obj_ADD:         len=1; a=0xf5; break;
    case Obj_BSUB:        len=1; a=0xf2; break;
    case Obj_AND:         a=0x24; b=0xf6; break;
    case Obj_OR:          a=0x24; b=0xfb; break;
    case Obj_XOR:         a=0x23; b=0xf3; break;
    case Obj_DIV:         a=0x22; b=0xfc; break;
    case Obj_SHL:         a=0x24; b=0xf1; break;
    case Obj_REM:         a=0x21; b=0xff; break;
    case Obj_MUL:         a=0x25; b=0xf3; break;
    case Obj_PROD:        len=1; a=0xf8; break;
    case Obj_SHR:         a=0x24; b=0xf0; break;
    case Obj_SUB:         len=1; a=0xfc; break;
    case Obj_DIFF:        len=1; a=0xf4; break;
    case Obj_LDIFF:       a=0x24; b=0xff; break;
    case Obj_SB:          a=0x23; b=0xfb; break;
    case Obj_RET:         a=0x22; b=0xf0; break;
    case Obj_GCALL:       len=1; a=0xf6; break;
    case Obj_REV:         len=1; a=0xf0; break;
    case Obj_GT:          len=1; a=0xf9; break;
    case Obj_XWORD:       a=0x23; b=0xfa; break;
    case Obj_LDIV:        a=0x21; b=0xfa; break;
    case Obj_MOVE:        a=0x24; b=0xfa; break;
    case Obj_WSUB:        len=1; a=0xfa; break;
    case Obj_DSUB:        a=0x28; b=0xf1; break;
    case Obj_T400:
    case Obj_T414:
    case Obj_T425:
    case Obj_T800:
    case Obj_T801:
    case Obj_T805:        return;
    case Obj_FPLDNLSN:    if (!hasfpu) { emitobj_s(Obj_CALL,"fpldnlsn"); return; } a=0x28; b=0xfe; break;
    case Obj_FPSTNLSN:    if (!hasfpu) { emitobj_s(Obj_CALL,"fpstnlsn"); return; } a=0x28; b=0xf8; break;
    case Obj_FPLDNLDB:    if (!hasfpu) { emitobj_s(Obj_CALL,"fpldnldb"); return; } a=0x28; b=0xfa; break;
    case Obj_FPSTNLDB:    if (!hasfpu) { emitobj_s(Obj_CALL,"fpstnldb"); return; } a=0x28; b=0xf4; break;
    case Obj_FPDBSTNLI32: if (!hasfpu) { emitobj_s(Obj_CALL,"fpdbstnli32"); return; } a=0x29; b=0xfe; break;
    case Obj_FPSNSTNLI32: if (!hasfpu) { emitobj_s(Obj_CALL,"fpsnstnli32"); return; } a=0x29; b=0xfe; break;
    case Obj_FPLDZEROSN:  if (!hasfpu) { emitobj_s(Obj_CALL,"fpldzerosn"); return; } a=0x29; b=0xff; break;
    case Obj_FPLDZERODB:  if (!hasfpu) { emitobj_s(Obj_CALL,"fpldzerodb"); return; } a=0x2a; b=0xf0; break;
    case Obj_FPREV:       if (!hasfpu) { emitobj_s(Obj_CALL,"fprev"); return; } a=0x2a; b=0xf4; break;
    case Obj_FPADDSN:     if (!hasfpu) { emitobj_s(Obj_CALL,"fpaddsn"); return; } a=0x28; b=0xf7; break;
    case Obj_FPADDDB:     if (!hasfpu) { emitobj_s(Obj_CALL,"fpadddb"); return; } a=0x28; b=0xf7; break;
    case Obj_FPSUBSN:     if (!hasfpu) { emitobj_s(Obj_CALL,"fpsubsn"); return; } a=0x28; b=0xf9; break;
    case Obj_FPSUBDB:     if (!hasfpu) { emitobj_s(Obj_CALL,"fpsubdb"); return; } a=0x28; b=0xf9; break;
    case Obj_FPMULSN:     if (!hasfpu) { emitobj_s(Obj_CALL,"fpmulsn"); return; } a=0x28; b=0xfb; break;
    case Obj_FPMULDB:     if (!hasfpu) { emitobj_s(Obj_CALL,"fpmuldb"); return; } a=0x28; b=0xfb; break;
    case Obj_FPDIVSN:     if (!hasfpu) { emitobj_s(Obj_CALL,"fpdivsn"); return; } a=0x28; b=0xfc; break;
    case Obj_FPDIVDB:     if (!hasfpu) { emitobj_s(Obj_CALL,"fpdivdb"); return; } a=0x28; b=0xfc; break;
    case Obj_FPEQSN:      if (!hasfpu) { emitobj_s(Obj_CALL,"fpeqsn"); return; } a=0x29; b=0xf5; break;
    case Obj_FPEQDB:      if (!hasfpu) { emitobj_s(Obj_CALL,"fpeqdb"); return; } a=0x29; b=0xf5; break;    
    case Obj_FPGTSN:      if (!hasfpu) { emitobj_s(Obj_CALL,"fpgtsn"); return; } a=0x29; b=0xf4; break;
    case Obj_FPGTDB:      if (!hasfpu) { emitobj_s(Obj_CALL,"fpgtdb"); return; } a=0x29; b=0xf4; break;
    case Obj_FPUR32TOR64: if (!hasfpu) { emitobj_s(Obj_CALL,"fpur32tor64"); return; } len=3; a=0x47; b=0x2a; c=0xfb; break;
    case Obj_FPUR64TOR32: if (!hasfpu) { emitobj_s(Obj_CALL,"fpur64tor32"); return; } len=3; a=0x48; b=0x2a; c=0xfb; break;
    case Obj_FPI32TOR64:  if (!hasfpu) { emitobj_s(Obj_CALL,"fpi32tor64"); return; } a=0x29; b=0xf8; break;
    case Obj_FPI32TOR32:  if (!hasfpu) { emitobj_s(Obj_CALL,"fpi32tor32"); return; } a=0x29; b=0xf6; break;
    case Obj_FPLDNLADDSN: if (!hasfpu) { emitobj_s(Obj_CALL,"fpldnladdsn"); return; } a=0x2a; b=0xfa; break;
    case Obj_FPLDNLADDDB: if (!hasfpu) { emitobj_s(Obj_CALL,"fpldnladddb"); return; } a=0x2a; b=0xf6; break;
    case Obj_FPLDNLMULSN: if (!hasfpu) { emitobj_s(Obj_CALL,"fpldnlmulsn"); return; } a=0x2a; b=0xfc; break;
    case Obj_FPLDNLMULDB: if (!hasfpu) { emitobj_s(Obj_CALL,"fpldnlmuldb"); return; } a=0x2a; b=0xf8; break;
    case Obj_FPINT:       if (!hasfpu) assert(0); a=0x2a; b=0xf1; break;
    case Obj_FPUMULBY2:   if (!hasfpu) assert(0); a=0x21; b=0x42; c=0x2a; d=0xfb; len=4; break;
    default:              assert(0);
  }
  outc(Obj_CODE); outc(len);
  if (len>=1) outc(a);
  if (len>=2) outc(b);
  if (len>=3) outc(c);
  if (len>=4) outc(d);
}
/*}}}*/
/* emitaddress   -- emit token with address+optional offset */ /*{{{*/
static void emitaddress(Objtag t, Symbol p)
{
  if (p->x.offset)
  {
    int label=genlabel(1);

    if (emittoken==emitobj)
    {
      emitobj_s(Obj_EQU,stringf("@Q%d",label));
      emitobj_s(Obj_SYMBOL,p->x.name);
      emitobj_i(Obj_NUMBER,p->x.offset);
      emitobj(Obj_EADD);
      emitobj(Obj_ENDEQU);
    }
    else if (emittoken==emitasm)
    {
      print(" equ @Q%d,%s+(%d)\n",label,p->x.name,p->x.offset);
    }
    else assert(0);
    (*emittoken_s)(t,stringf("@Q%d",label));
  }
  else (*emittoken_s)(t,p->x.name);
}
/*}}}*/
/* emittree      -- emit a tree of dags */ /*{{{*/
static void emittree(Node p, Node top, int load)
{
  if (p)
  {
    if (p->x.top!=top) /* only load result of foreign node */ /*{{{*/
    {
      if (load && p->x.tree_result) switch (typecode(p))
      {
        /* F */ /*{{{*/
        case F:
        {
          (*emittoken_i)(Obj_LDLP,words(p->x.tree_result->x.offset+argoffset));
          (*emittoken)(Obj_FPLDNLSN);
          break;
        }
        /*}}}*/
        /* D */ /*{{{*/
        case D:
        {
          (*emittoken_i)(Obj_LDLP,words(p->x.tree_result->x.offset+argoffset));
          (*emittoken)(Obj_FPLDNLDB);
          break;
        }
        /*}}}*/
        /* PICUS    */ /*{{{*/
        case P:
        case I:
        case C:
        case U:
        case S:
        {
          (*emittoken_i)(Obj_LDL,words(p->x.tree_result->x.offset+argoffset));
          break;
        }
        /*}}}*/
        /* default */ /*{{{*/
        default: assert(0);
        /*}}}*/
      }
    }
    /*}}}*/
    else /* emit code for node */ /*{{{*/
    {
      /* emit childs of operator */ /*{{{*/
      switch(p->x.genorder)
      {
        /* NORMAL */ /*{{{*/
        case NORMAL: emittree(p->kids[0],top,1); emittree(p->kids[1],top,1); break;
        /*}}}*/
        /* SWAP_REV */ /*{{{*/
        case SWAP_REV:
        {
          assert(p->x.ioper || p->x.foper);
          emittree(p->kids[0],top,1);
          emittree(p->kids[1],top,1);
          if (p->x.ioper) (*emittoken)(Obj_REV); else (*emittoken)(Obj_FPREV);
          break;
        }
        /*}}}*/
        /* TEMP */ /*{{{*/
        case TEMP:
        {
          assert(p->x.ioper || p->x.foper);
          emittree(p->kids[0],top,0);
          emittree(p->kids[1],top,1);
          if (p->x.ioper) (*emittoken_i)(Obj_LDL,words(p->kids[0]->x.tree_result->x.offset+argoffset));
          else
          {
            (*emittoken_i)(Obj_LDLP,words(p->kids[0]->x.tree_result->x.offset+argoffset));
            (*emittoken)(typecode(p)==F ? Obj_FPSTNLSN : Obj_FPSTNLDB);
          }
          break;
        }
        /*}}}*/
        /* NORMAL_0 */ /*{{{*/
        case NORMAL_0:
        {
          assert(p->x.uoper);
          switch (p->op)
          {
            case GTU:
            case GEU:
            case LTU:
            case LEU: (*emittoken_i)(Obj_LDC,1); break;
            default: (*emittoken_i)(Obj_LDC,0); break;
          }
          emittree(p->kids[0],top,1);
          emittree(p->kids[1],top,1);
          break;
        }
        /*}}}*/
        /* NORMAL_0REV */ /*{{{*/
        case NORMAL_0REV:
        {
          assert(p->x.uoper);
          emittree(p->kids[0],top,1);
          switch (p->op)
          {
            case GTU:
            case GEU:
            case LTU:
            case LEU: (*emittoken_i)(Obj_LDC,1); break;
            default: (*emittoken_i)(Obj_LDC,0); break;
          }
          (*emittoken)(Obj_REV);
          emittree(p->kids[1],top,1);
          break;
        }
        /*}}}*/
        /* TEMP_0 */ /*{{{*/
        case TEMP_0:
        {
          assert(p->x.uoper);
          emittree(p->kids[0],top,0);
          switch (p->op)
          {
            case GTU:
            case GEU:
            case LTU:
            case LEU: (*emittoken_i)(Obj_LDC,1); break;
            default: (*emittoken_i)(Obj_LDC,0); break;
          }
          emittree(p->kids[1],top,1);
          (*emittoken_i)(Obj_LDL,words(p->kids[0]->x.tree_result->x.offset+argoffset));
          break;
        }
        /*}}}*/
        /* TEMP_0SWAPREV */ /*{{{*/
        case TEMP_0SWAPREV:
        {
          assert(p->x.uoper);
          emittree(p->kids[0],top,0);
          switch (p->op)
          {
            case GTU:
            case GEU:
            case LTU:
            case LEU: (*emittoken_i)(Obj_LDC,1); break;
            default: (*emittoken_i)(Obj_LDC,0); break;
          }
          emittree(p->kids[1],top,1);
          (*emittoken_i)(Obj_LDL,words(p->kids[0]->x.tree_result->x.offset+argoffset));
          (*emittoken)(Obj_REV);
          break;
        }
        /*}}}*/
        /* TEMP_0SWAP */ /*{{{*/
        case TEMP_0SWAP:
        {
          assert(p->x.uoper);
          emittree(p->kids[0],top,0);
          emittree(p->kids[1],top,1);
          switch (p->op)
          {
            case GTU:
            case GEU:
            case LTU:
            case LEU: (*emittoken_i)(Obj_LDC,1); break;
            default: (*emittoken_i)(Obj_LDC,0); break;
          }
          (*emittoken)(Obj_REV);
          (*emittoken_i)(Obj_LDL,words(p->kids[0]->x.tree_result->x.offset+argoffset));
          break;
        }
        /*}}}*/
        /* default */ /*{{{*/
        default: assert(0);
        /*}}}*/
      }
      /*}}}*/
#    ifdef SYMDEBUG
      /* output Node in symbolic form */ /*{{{*/
      if (emittoken==emitasm)
      {
        int i;

        print
        (
          "; com=%d iop=%d uop=%d fop=%d %s %d %d node%c%d top=%d %s count=%d",
          commutes(p->op),
          p->x.ioper,
          p->x.uoper,
          p->x.foper,
          genordertype(p),
          depth(p, top),
          fdepth(p, top),
          p==top ? '\'' : '#',
          p->x.id,
          top->x.id,
          xopname(p->op),
          p->count
        );
        for (i=0; i<MAXKIDS && p->kids[i]; i++) print(" #%d", p->kids[i]->x.id);
        for (i=0; i<MAXSYMS && p->syms[i]; i++)
        {
          if (p->syms[i]->x.name) print(" %s", p->syms[i]->x.name);
          if (p->syms[i]->name!=p->syms[i]->x.name) print(" (%s)", p->syms[i]->name);
        }
        print("\n");
      }
      /*}}}*/
#    endif
      /* output Node */ /*{{{*/
      switch (p->op)
      {
        /* standard opcodes */ /*{{{*/
        /* ADDRFP */ /*{{{*/
        case ADDRFP:
        {
          int b;

          (*emittoken_i)(Obj_LDLP,words(p->syms[0]->x.offset+maxoffset+bytes(1)+argoffset));
          if ((b=(p->syms[0]->x.offset)-bytes(words(p->syms[0]->x.offset)))>0) (*emittoken_i)(Obj_ADC,b);
          break;
        }
        /*}}}*/
        /* ADDRGP */ /*{{{*/
        case ADDRGP:  emitaddress(Obj_LDPI,p->syms[0]); break;
        /*}}}*/
        /* ADDRLP */ /*{{{*/
        case ADDRLP:
        {
          int b;

          (*emittoken_i)(Obj_LDLP,words(p->syms[0]->x.offset+argoffset));
          if ((b=p->syms[0]->x.offset-bytes(words(p->syms[0]->x.offset)))>0) (*emittoken_i)(Obj_ADC,b);
          break;
        }
        /*}}}*/
        /* CNST[CSIUP] */ /*{{{*/
        case CNSTP:
        case CNSTC:
        case CNSTS:
        case CNSTI:
        case CNSTU:   (*emittoken_i)(Obj_LDC,p->syms[0]->u.c.v.u); break;
        /*}}}*/
        /* CNST[FD] */ /*{{{*/
        case CNSTF:
        case CNSTD: assert(0); break;
        /*}}}*/
        /* BCOMU */ /*{{{*/
        case BCOMU:   (*emittoken)(Obj_NOT); break;
        /*}}}*/
        /* CVCI */ /*{{{*/
        case CVCI: (*emittoken_i)(Obj_LDC,0x80); (*emittoken)(Obj_XWORD); break;
        /*}}}*/
        /* CVCU */ /*{{{*/
        case CVCU: break;
        /*}}}*/
        /* CVDI */ /*{{{*/
        case CVDI:
        {
          assert(p->x.temp);
          checkfpu();
          (*emittoken_i)(Obj_LDLP,words(p->x.temp->x.offset+argoffset));
          if (hasfpu) (*emittoken)(Obj_FPINT);
          (*emittoken)(Obj_FPDBSTNLI32);
          (*emittoken_i)(Obj_LDL,words(p->x.temp->x.offset+argoffset));
          break;
        }
        /*}}}*/
        /* CVFI */ /*{{{*/
        case CVFI:
        {
          assert(p->x.temp);
          checkfpu();
          (*emittoken_i)(Obj_LDLP,words(p->x.temp->x.offset+argoffset));
          if (hasfpu) (*emittoken)(Obj_FPINT);
          (*emittoken)(Obj_FPSNSTNLI32);
          (*emittoken_i)(Obj_LDL,words(p->x.temp->x.offset+argoffset));
          break;
        }
        /*}}}*/
        /* CVDF */ /*{{{*/
        case CVDF: checkfpu(); (*emittoken)(Obj_FPUR64TOR32); break;
        /*}}}*/
        /* CVFD */ /*{{{*/
        case CVFD: checkfpu(); (*emittoken)(Obj_FPUR32TOR64); break;
        /*}}}*/
        /* CVIC */ /*{{{*/
        case CVIC: (*emittoken_i)(Obj_LDC,0xff); (*emittoken)(Obj_AND); break;
        /*}}}*/
        /* CVIS */ /*{{{*/
        case CVIS: (*emittoken_i)(Obj_LDC,0xffff); (*emittoken)(Obj_AND); break;
        /*}}}*/
        /* CVIU */ /*{{{*/
        case CVIU: break;
        /*}}}*/
        /* CVID */ /*{{{*/
        case CVID:
        {
          assert(p->x.temp);
          checkfpu();
          (*emittoken_i)(Obj_STL,words(p->x.temp->x.offset+argoffset));
          (*emittoken_i)(Obj_LDLP,words(p->x.temp->x.offset+argoffset));
          (*emittoken)(Obj_FPI32TOR64);
          break;
        }
        /*}}}*/
        /* CVIF */ /*{{{*/
        case CVIF:
        {
          assert(p->x.temp);
          checkfpu();
          (*emittoken_i)(Obj_STL,words(p->x.temp->x.offset+argoffset));
          (*emittoken_i)(Obj_LDLP,words(p->x.temp->x.offset+argoffset));
          (*emittoken)(Obj_FPI32TOR32);
          break;
        }
        /*}}}*/
        /* CVPU */ /*{{{*/
        case CVPU: break;
        /*}}}*/
        /* CVSI */ /*{{{*/
        case CVSI: (*emittoken_i)(Obj_LDC,0x8000); (*emittoken)(Obj_XWORD); break;
        /*}}}*/
        /* CVSU */ /*{{{*/
        case CVSU: break;
        /*}}}*/
        /* CVUC */ /*{{{*/
        case CVUC: (*emittoken_i)(Obj_LDC,0xff); (*emittoken)(Obj_AND); break;
        /*}}}*/
        /* CVUS */ /*{{{*/
        case CVUS: (*emittoken_i)(Obj_LDC,0xffff); (*emittoken)(Obj_AND); break;
        /*}}}*/
        /* CVUI, CVUP */ /*{{{*/
        case CVUI:
        case CVUP: break;
        /*}}}*/
        /* INDIRC */ /*{{{*/
        case INDIRC:  (*emittoken)(Obj_LB); break;
        /*}}}*/
        /* INDIRS */ /*{{{*/
        case INDIRS:
        {
          assert(p->x.temp);
          (*emittoken_i)(Obj_LDC,0);
          (*emittoken_i)(Obj_STL,words(p->x.temp->x.offset+argoffset));
          (*emittoken_i)(Obj_LDLP,words(p->x.temp->x.offset+argoffset));
          (*emittoken_i)(Obj_LDC,2);
          (*emittoken)(Obj_MOVE);
          (*emittoken_i)(Obj_LDL,words(p->x.temp->x.offset+argoffset));
          break;
        }
        /*}}}*/
        /* INDIRI, INDIRP */ /*{{{*/
        case INDIRI:
        case INDIRP:  (*emittoken_i)(Obj_LDNL,0); break;
        /*}}}*/
        /* INDIRF */ /*{{{*/
        case INDIRF: checkfpu(); (*emittoken)(Obj_FPLDNLSN); break;
        /*}}}*/
        /* INDIRD */ /*{{{*/
        case INDIRD: checkfpu(); (*emittoken)(Obj_FPLDNLDB); break;
        /*}}}*/
        /* INDIRB */ /*{{{*/
        case INDIRB:  break;
        /*}}}*/
        /* NEGI */ /*{{{*/
        case NEGI: (*emittoken)(Obj_NOT); (*emittoken_i)(Obj_ADC,1); break;
        /*}}}*/
        /* NEGF */ /*{{{*/
        case NEGF:
        {
          checkfpu();
          (*emittoken)(Obj_FPLDZEROSN);
          (*emittoken)(Obj_FPREV);
          (*emittoken)(Obj_FPSUBSN);
          break;
        }
        /*}}}*/
        /* NEGD */ /*{{{*/
        case NEGD:
        {
          checkfpu();
          (*emittoken)(Obj_FPLDZERODB);
          (*emittoken)(Obj_FPREV);
          (*emittoken)(Obj_FPSUBDB);
          break;
        }
        /*}}}*/
        /* ADD[PI] */ /*{{{*/
        case ADDP:
        case ADDI:    (*emittoken)(Obj_ADD); break;
        /*}}}*/
        /* ADDU */ /*{{{*/
        case ADDU:    (*emittoken)(Obj_BSUB); break;
        /*}}}*/
        /* ADDF */ /*{{{*/
        case ADDF: checkfpu(); (*emittoken)(Obj_FPADDSN); break;
        /*}}}*/
        /* ADDD */ /*{{{*/
        case ADDD: checkfpu(); (*emittoken)(Obj_FPADDDB); break;
        /*}}}*/
        /* BANDU */ /*{{{*/
        case BANDU:   (*emittoken)(Obj_AND); break;
        /*}}}*/
        /* BORU */ /*{{{*/
        case BORU:    (*emittoken)(Obj_OR); break;
        /*}}}*/
        /* BXORU */ /*{{{*/
        case BXORU:   (*emittoken)(Obj_XOR); break;
        /*}}}*/
        /* DIVI */ /*{{{*/
        case DIVI:    (*emittoken)(Obj_DIV); break;
        /*}}}*/
        /* DIVU */ /*{{{*/
        case DIVU:    (*emittoken)(Obj_LDIV); break;
        /*}}}*/
        /* DIVF */ /*{{{*/
        case DIVF: checkfpu(); (*emittoken)(Obj_FPDIVSN); break;
        /*}}}*/
        /* DIVD */ /*{{{*/
        case DIVD: checkfpu(); (*emittoken)(Obj_FPDIVDB); break;
        /*}}}*/
        /* LSH[IU] */ /*{{{*/
        case LSHI:
        case LSHU:    (*emittoken)(Obj_SHL); break;
        /*}}}*/
        /* MODI */ /*{{{*/
        case MODI:    (*emittoken)(Obj_REM); break;
        /*}}}*/
        /* MODU */ /*{{{*/
        case MODU:    (*emittoken)(Obj_LDIV); (*emittoken)(Obj_REV); break;
        /*}}}*/
        /* MULI */ /*{{{*/
        case MULI:    (*emittoken)(Obj_MUL); break;
        /*}}}*/
        /* MULU */ /*{{{*/
        case MULU:    (*emittoken)(Obj_PROD); break;
        /*}}}*/
        /* MULF */ /*{{{*/
        case MULF: checkfpu(); (*emittoken)(Obj_FPMULSN); break;
        /*}}}*/
        /* MULD */ /*{{{*/
        case MULD: checkfpu(); (*emittoken)(Obj_FPMULDB); break;
        /*}}}*/
        /* RSH[UI] */ /*{{{*/
        case RSHI:
        case RSHU:    (*emittoken)(Obj_SHR); break;
        /*}}}*/
        /* SUB[PI] */ /*{{{*/
        case SUBP:
        case SUBI:    (*emittoken)(Obj_SUB); break;
        /*}}}*/
        /* SUBU */ /*{{{*/
        case SUBU:    (*emittoken)(Obj_DIFF); break;
        /*}}}*/
        /* SUBD */ /*{{{*/
        case SUBD: checkfpu(); (*emittoken)(Obj_FPSUBDB);  break;
        /*}}}*/
        /* SUBF */ /*{{{*/
        case SUBF: checkfpu(); (*emittoken)(Obj_FPSUBSN);  break;
        /*}}}*/
        /* ASGNC */ /*{{{*/
        case ASGNC:   (*emittoken)(Obj_SB); break;
        /*}}}*/
        /* ASGNS */ /*{{{*/
        case ASGNS:
        {
          assert(p->kids[0]->x.tree_result);
          (*emittoken_i)(Obj_LDLP,words(p->kids[0]->x.tree_result->x.offset+argoffset));
          (*emittoken)(Obj_REV);
          (*emittoken_i)(Obj_LDC,2);
          (*emittoken)(Obj_MOVE);
          break;
        }
        /*}}}*/
        /* ASGNI, ASGNP */ /*{{{*/
        case ASGNI:
        case ASGNP:   (*emittoken_i)(Obj_STNL,0); break;
        /*}}}*/
        /* ASGNF */ /*{{{*/
        case ASGNF: checkfpu(); (*emittoken)(Obj_FPSTNLSN); break;
        /*}}}*/
        /* ASGND */ /*{{{*/
        case ASGND: checkfpu(); (*emittoken)(Obj_FPSTNLDB); break;
        /*}}}*/
        /* ASGNB */ /*{{{*/
        case ASGNB:
        {
          (*emittoken_i)(Obj_LDC,p->syms[0]->u.c.v.u);
          (*emittoken)(Obj_MOVE);
          break;
        }
        /*}}}*/
        /* EQI */ /*{{{*/
        case EQI:     (*emittoken)(Obj_DIFF);
                      (*emittoken_s)(Obj_CJ,p->syms[0]->x.name); break;
        /*}}}*/
        /* EQF */ /*{{{*/
        case EQF:
        {
          checkfpu();
          (*emittoken)(Obj_FPEQSN);
          (*emittoken_i)(Obj_EQC,0);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* EQD */ /*{{{*/
        case EQD:
        {
          checkfpu();
          (*emittoken)(Obj_FPEQDB);
          (*emittoken_i)(Obj_EQC,0);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* GEI */ /*{{{*/
        case GEI:     (*emittoken)(Obj_GT);
                      (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
                      break;
        /*}}}*/
        /* GEU */ /*{{{*/
        case GEU:
                      (*emittoken)(Obj_LDIFF);
                      (*emittoken)(Obj_REV);
                      (*emittoken_i)(Obj_EQC,0);
                      (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
                      break;
        /*}}}*/
        /* GEF */ /*{{{*/
        case GEF:
        {
          checkfpu();
          (*emittoken)(Obj_FPGTSN);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* GED */ /*{{{*/
        case GED:
        {
          checkfpu();
          (*emittoken)(Obj_FPGTDB);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* GTI */ /*{{{*/
        case GTI:     (*emittoken)(Obj_GT);
                      (*emittoken_i)(Obj_EQC,0);
                      (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
                      break;
        /*}}}*/
        /* GTU */ /*{{{*/
        case GTU:
                      (*emittoken)(Obj_LDIFF);
                      (*emittoken)(Obj_REV);
                      (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
                      break;
        /*}}}*/
        /* GTF */ /*{{{*/
        case GTF:
        {
          checkfpu();
          (*emittoken)(Obj_FPGTSN);
          (*emittoken_i)(Obj_EQC,0);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* GTD */ /*{{{*/
        case GTD:
        {
          checkfpu();
          (*emittoken)(Obj_FPGTDB);
          (*emittoken_i)(Obj_EQC,0);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* LEI */ /*{{{*/
        case LEI:     (*emittoken)(Obj_GT);
                      (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
                      break;
        /*}}}*/
        /* LEU */ /*{{{*/
        case LEU:     (*emittoken)(Obj_LDIFF);
                      (*emittoken)(Obj_REV);
                      (*emittoken_i)(Obj_EQC,0);
                      (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
                      break;
        /*}}}*/
        /* LEF */ /*{{{*/
        case LEF:
        {
          checkfpu();
          (*emittoken)(Obj_FPGTSN);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* LED */ /*{{{*/
        case LED:
        {
          checkfpu();
          (*emittoken)(Obj_FPGTDB);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* LTI */ /*{{{*/
        case LTI:     (*emittoken)(Obj_GT);
                      (*emittoken_i)(Obj_EQC,0);
                      (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
                      break;
        /*}}}*/
        /* LTU */ /*{{{*/
        case LTU:     (*emittoken)(Obj_LDIFF);
                      (*emittoken)(Obj_REV);
                      (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
                      break;
        /*}}}*/
        /* LTF */ /*{{{*/
        case LTF:
        {
          checkfpu();
          (*emittoken)(Obj_FPGTSN);
          (*emittoken_i)(Obj_EQC,0);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* LTD */ /*{{{*/
        case LTD:
        {
          checkfpu();
          (*emittoken)(Obj_FPGTDB);
          (*emittoken_i)(Obj_EQC,0);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* NEI */ /*{{{*/
        case NEI:
        {
          (*emittoken)(Obj_DIFF);
          (*emittoken_i)(Obj_EQC,0);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* NEF */ /*{{{*/
        case NEF:
        {
          checkfpu();
          (*emittoken)(Obj_FPEQSN);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* NED */ /*{{{*/
        case NED:
        {
          checkfpu();
          (*emittoken)(Obj_FPEQDB);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* ARG[IP] */ /*{{{*/
        case ARGI:
        case ARGP:
        {
          (*emittoken_i)(Obj_AJW,-words(p->syms[0]->u.c.v.i));
          argoffset+=(p->syms[0]->u.c.v.u);
          (*emittoken_i)(Obj_STL,0);
          break;
        }
        /*}}}*/
        /* ARGF */ /*{{{*/
        case ARGF:
        {
          checkfpu();
          (*emittoken_i)(Obj_AJW,-words(p->syms[0]->u.c.v.i));
          argoffset+=(p->syms[0]->u.c.v.u);
          (*emittoken_i)(Obj_LDLP,0);
          (*emittoken)(Obj_FPSTNLSN);
          break;
        }
        /*}}}*/
        /* ARGD */ /*{{{*/
        case ARGD:
        {
          checkfpu();
          (*emittoken_i)(Obj_AJW,-words(p->syms[0]->u.c.v.i));
          argoffset+=(p->syms[0]->u.c.v.u);
          (*emittoken_i)(Obj_LDLP,0);
          (*emittoken)(Obj_FPSTNLDB);
          break;
        }
        /*}}}*/
        /* ARGB */ /*{{{*/
        case ARGB:
        {
          (*emittoken_i)(Obj_AJW,-words(p->syms[0]->u.c.v.i));
          argoffset+=(p->syms[0]->u.c.v.u);
          (*emittoken_i)(Obj_LDLP,0);
          (*emittoken_i)(Obj_LDC,p->syms[0]->u.c.v.u);
          (*emittoken)(Obj_MOVE);
          break;
        }
        /*}}}*/
        /* CALL[FDIV] */ /*{{{*/
        case CALLF:
        case CALLD: checkfpu();
        case CALLI:
        case CALLV:
        {
          int label=genlabel(1);

          /* ret can not cause descheduling, so this technique is safe */
          (*emittoken_i)(Obj_AJW,-1);
          (*emittoken_s)(Obj_LDPI,stringf("@Q%d",label));
          (*emittoken_i)(Obj_STL,0);
          (*emittoken)(Obj_GCALL);
          (*emittoken_s)(Obj_LABEL,stringf("@Q%d",label));
          (*emittoken_i)(Obj_AJW,words(argoffset)-3);
          argoffset=0;
          break;
        }
        /*}}}*/
        /* CALLB */ /*{{{*/
        case CALLB: assert(0); break; /* is never used */
        /*}}}*/
        /* RET[FDIV] */ /*{{{*/
        case RETF:
        case RETD: checkfpu();
        case RETI:
        case RETV:
        {
          (*emittoken_i)(Obj_AJW,words(maxoffset));
          (*emittoken)(Obj_RET);
          break;
        }
        /*}}}*/
        /* JUMPV */ /*{{{*/
        case JUMPV:   (*emittoken)(Obj_GCALL); break;
        /*}}}*/
        /* LABELV */ /*{{{*/
        case LABELV:  (*emittoken_s)(Obj_LABEL,p->syms[0]->x.name); break;
        /*}}}*/
        /*}}}*/
        /* extended opcodes */ /*{{{*/
        /* FINDIRI, FINDIRP */ /*{{{*/
        case FINDIRI:
        case FINDIRP: (*emittoken_i)(Obj_LDL,words(p->syms[0]->x.offset+maxoffset+bytes(1)+argoffset)); break;
        /*}}}*/
        /* LINDIRI, LINDIRP */ /*{{{*/
        case LINDIRI:
        case LINDIRP: (*emittoken_i)(Obj_LDL,words(p->syms[0]->x.offset+argoffset)); break;
        /*}}}*/
        /* CADDI */ /*{{{*/
        case CADDI:   (*emittoken_i)(Obj_ADC,p->syms[0]->u.c.v.i); break;
        /*}}}*/
        /* CADDP */ /*{{{*/
        case CADDP:   (*emittoken_i)(Obj_LDNLP,p->syms[0]->u.c.v.i); break;
        /*}}}*/
        /* GJUMPV */ /*{{{*/
        case GJUMPV:  (*emittoken_s)(Obj_JUMP,p->syms[0]->x.name); break;
        /*}}}*/
        /* FASGNI, FASGNP */ /*{{{*/
        case FASGNI:
        case FASGNP:  (*emittoken_i)(Obj_STL,words(p->syms[0]->x.offset+maxoffset+bytes(1)+argoffset)); break;
        /*}}}*/
        /* LASGNI, LASGNP */ /*{{{*/
        case LASGNI:
        case LASGNP:  (*emittoken_i)(Obj_STL,words(p->syms[0]->x.offset+argoffset)); break;
        /*}}}*/
        /* CEQI */ /*{{{*/
        case CEQI:
        {
          if (p->syms[1]->u.c.v.i!=0)
          {
            (*emittoken_i)(Obj_EQC,p->syms[1]->u.c.v.i);
            (*emittoken_i)(Obj_EQC,0);
          }
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* CNEI */ /*{{{*/
        case CNEI:
        {
          (*emittoken_i)(Obj_EQC,p->syms[1]->u.c.v.i);
          (*emittoken_s)(Obj_CJ,p->syms[0]->x.name);
          break;
        }
        /*}}}*/
        /* GCALL[IFDV] */ /*{{{*/
        case GCALLI:
        case GCALLF:
        case GCALLD:
        case GCALLV:
        {
          if (strcmp(p->syms[0]->x.name,"__alloca")==0) (*emittoken_i)(Obj_LDLP,words(argoffset+maxoffset));
          (*emittoken_s)(Obj_CALL,p->syms[0]->x.name);
          (*emittoken_i)(Obj_AJW,words(argoffset));
          argoffset=0;
          break;
        }
        /*}}}*/
        /* GARG[IP] */ /*{{{*/
        case GARGI:
        case GARGP: break;
        /*}}}*/
        /* WADDP */ /*{{{*/
        case WADDP:   (*emittoken)(Obj_WSUB); break;
        /*}}}*/
        /* DADDP */ /*{{{*/
        case DADDP:   (*emittoken)(Obj_DSUB); break;
        /*}}}*/
        /* CASGNI, CASGNP */ /*{{{*/
        case CASGNI:
        case CASGNP:  (*emittoken_i)(Obj_STNL,words(p->syms[2]->u.c.v.i)); break;
        /*}}}*/
        /* CINDIRI, CINDIRP */ /*{{{*/
        case CINDIRI:
        case CINDIRP:  (*emittoken_i)(Obj_LDNL,words(p->syms[0]->u.c.v.i)); break;
        /*}}}*/
        /* INDIRADDF */ /*{{{*/
        case INDIRADDF: checkfpu(); (*emittoken)(Obj_FPLDNLADDSN); break;
        /*}}}*/
        /* INDIRADDD */ /*{{{*/
        case INDIRADDD: checkfpu(); (*emittoken)(Obj_FPLDNLADDDB); break;
        /*}}}*/
        /* INDIRMULF */ /*{{{*/
        case INDIRMULF: checkfpu(); (*emittoken)(Obj_FPLDNLMULSN); break;
        /*}}}*/
        /* INDIRMULD */ /*{{{*/
        case INDIRMULD: checkfpu(); (*emittoken)(Obj_FPLDNLMULDB); break;
        /*}}}*/
        /* ALINDIRS */ /*{{{*/
        case ALINDIRS:
        (*emittoken_i)(Obj_LDL,words(p->syms[0]->x.offset+argoffset));
        (*emittoken_i)(Obj_LDC,0xffff);
        (*emittoken)(Obj_AND);
        break;
        /*}}}*/
        /* NLINDIRS */ /*{{{*/
        case NLINDIRS:
        (*emittoken_i)(Obj_LDL,words(p->syms[0]->x.offset+argoffset));
        (*emittoken_i)(Obj_LDC,16);
        (*emittoken)(Obj_SHR);
        break;
        /*}}}*/
        /* MULD2 */ /*{{{*/
        case MULD2:
        (*emittoken)(Obj_FPUMULBY2);
        break;
        /*}}}*/
        /*}}}*/
        /* default */ /*{{{*/
        default: print("opcode %d\n",p->op); assert(0);
        /*}}}*/
      }
      /*}}}*/
      /* save node result, if needed */ /*{{{*/
      if (p->x.tree_result) switch (typecode(p))
      {
        /* F */ /*{{{*/
        case F:
        {
          (*emittoken_i)(Obj_LDLP,words(p->x.tree_result->x.offset+argoffset));
          (*emittoken)(Obj_FPSTNLSN);
          break;
        }
        /*}}}*/
        /* D */ /*{{{*/
        case D:
        {
          (*emittoken_i)(Obj_LDLP,words(p->x.tree_result->x.offset+argoffset));
          (*emittoken)(Obj_FPSTNLDB);
          break;
        }
        /*}}}*/
        /* PICUS */ /*{{{*/
        case P:
        case I:
        case C:
        case U:
        case S:
        {
          (*emittoken_i)(Obj_STL,words(p->x.tree_result->x.offset+argoffset));
          break;
        }
        /*}}}*/
        default: assert(0);
      }
      /*}}}*/
    }
    /*}}}*/
  }
}
/*}}}*/

/* space         -- emit define space */ /*{{{*/
void space(int x)
{
  (*emittoken_i)(Obj_DS,x);
}
/*}}}*/
/* segment       -- switch to segment */ /*{{{*/
void segment(int x)
{
#ifdef SYMDEBUG
  if (emittoken==emitasm) print("; segment %s\n", &"text\0bss\0.data\0lit\0.sym\0."[5*(x)-5]);
#endif
}
/*}}}*/
/* address       -- initialize symbol for addressing expression p+n */ /*{{{*/
void address(Symbol q, Symbol p, int n)
{
  q->x.name = p->x.name;
  q->x.offset = p->x.offset+n;
}
/*}}}*/
/* asmcode       -- emit assembly language specified by asm() */ /*{{{*/
void asmcode(char *str, Symbol argv[])
{
  if (emittoken!=emitasm)
  {
    error("asm() can not be converted to object format\n");
    return;
  }
  for (; *str; ++str) if (*str == '%' && str[1] >= 0 && str[1] <= 9)
  {
    switch (argv[*++str]->scope)
    {
      /* PARAM */ /*{{{*/
      case PARAM:
      {
        int b;

        print("%d",words(argv[*str]->x.offset+argoffset+maxoffset+bytes(1)));
        if ((b=argv[*str]->x.offset-bytes(words(argv[*str]->x.offset)))>0) print("\n adc %d",b);
        break;
      }
      /*}}}*/
      /* GLOBAL */ /*{{{*/
      case GLOBAL: print("%s",argv[*str]->x.name); break;
      /*}}}*/
      /* default (==LOCAL+k) */ /*{{{*/
      default:
      {
        int b;

        print("%d",words(argv[*str]->x.offset+argoffset));
        if ((b=argv[*str]->x.offset-bytes(words(argv[*str]->x.offset)))>0) print("\n adc %d",b);
        break;
      }
      /*}}}*/
    }
  }
  else *bp++ = *str;
  print("\n");
}
/*}}}*/
/* blockbeg      -- begin a compound statement */ /*{{{*/
void blockbeg(Env *e)
{
  *e=offset;
}
/*}}}*/
/* blockend      -- end a compound statement */ /*{{{*/
void blockend(Env *e)
{
  if (offset > maxoffset) maxoffset = offset;
  offset = *e;
}
/*}}}*/
/* global        -- emit a global symbol */ /*{{{*/
void global(Symbol p)
{
  if (p->type->align==4) (*emittoken)(Obj_ALIGN);
  (*emittoken_s)(Obj_LABEL,p->x.name);
}
/*}}}*/
/* defaddress    -- emit an address (with optional offset) */ /*{{{*/
void defaddress(Symbol p)
{
  emitaddress(Obj_D32,p);
}
/*}}}*/
/* defconst      -- emit a numeric constant */ /*{{{*/
void defconst(int ty, Value v)
{
  switch (ty)
  {
    case C: (*emittoken_i)(Obj_D8,(int)v.uc); break;
    case S: (*emittoken_i)(Obj_D16,(int)v.us); break;
    case I: (*emittoken_i)(Obj_D32,(int)v.i); break;
    case U: (*emittoken_i)(Obj_D32,(int)v.u); break;
    case P: (*emittoken_i)(Obj_D32,(int)v.p); break;
    case F: (*emittoken_i)(Obj_D32,((unsigned *) &v.f)[0]); break;
    case D:
    {
      (*emittoken_i)(Obj_D32,((unsigned *) &v.d)[0]);
      (*emittoken_i)(Obj_D32,((unsigned *) &v.d)[1]);
      break;
    }
    default: assert(0);
  }
}
/*}}}*/
/* defstring     -- emit a string constant */ /*{{{*/
void defstring(int len, char *s)
{
  while (len-->0) (*emittoken_i)(Obj_D8,(int)((unsigned char)(*s++)));
}
/*}}}*/
/* defsymbol     -- initialize Xsymbol after defining a new symbol */ /*{{{*/
void defsymbol(Symbol p)
{
  if (p->scope==CONSTANTS || (p->scope>=LOCAL && p->sclass==STATIC)) p->x.name=stringf("@Q%d",genlabel(1));
  else if (p->generated) p->x.name=stringf("@Q%s",p->name);
  else if (p->sclass==STATIC) p->x.name=stringf("@_%s",p->name);
  else p->x.name=stringf("_%s",p->name);
}
/*}}}*/
/* emit          -- emit a list of dags */ /*{{{*/
void emit(Node p)
{
#ifdef SYMDEBUG
  if (emittoken==emitasm) print("; ---list\n");
#endif
  for (; p; p=p->link)
  {
#ifdef SYMDEBUG
    if (emittoken==emitasm) print("; ---tree\n");
#endif
    emittree(p,p,0);
  }
}
/*}}}*/
/* function      -- emit code for a function */ /*{{{*/
void function(Symbol f, Symbol caller[], Symbol callee[], int ncalls)
{
  int i;

  (*emittoken_s)(Obj_LABEL,f->x.name);
#ifdef SYMDEBUG
  if (emittoken==emitasm)
  {
    sym("; function", f, ncalls ? 0 : "\n");
    if (ncalls) print(" ncalls=%d\n", ncalls);
  }
#endif
  offset = 0;
  for (i=0; caller[i] && callee[i]; i++)
  {
    offset = roundup(offset, caller[i]->type->align);
    caller[i]->x.name = caller[i]->name;
    callee[i]->x.name = callee[i]->name;
    callee[i]->sclass = AUTO;
    caller[i]->x.offset = callee[i]->x.offset = offset;
#ifdef SYMDEBUG
    if (emittoken==emitasm)
    {
      sym("; caller's parameter", caller[i], "\n");
      sym("; callee's parameter", callee[i], "\n");
    }
#endif
    offset += caller[i]->type->size;
  }
  maxoffset = offset = 0;
  gencode(caller, callee);
  maxoffset=bytes(words(maxoffset+3));
  (*emittoken_i)(Obj_AJW,-words(maxoffset));
  emitcode();
}
/*}}}*/
/* gen           -- prepare a list of trees for code generation */ /*{{{*/
Node gen(Node topnode)
{
  /* variables */ /*{{{*/
  int n;
  Node p;
  /*}}}*/

  initautotemp();
  /* attribute and generate tree */ /*{{{*/
  for (n=0,p=topnode; p; p=p->link)
  {
#   ifndef NDEBUG
    switch (generic(p->op))
    {
      case CALL: break;
      case ARG:
      case ASGN:
      case JUMP:
      case LABEL:
      case RET:
      case EQ:
      case GE:
      case GT:
      case LE:
      case LT:
      case NE: assert(p->count == 0); break;
      case INDIR: assert(p->count > 0); break;
      default: assert(0);
    }
#   endif
    n=attrtree(p, n, p);
    begin=1; reordertree(p,p);
  }
  /*}}}*/
  /* allocate temporaries */ /*{{{*/
  for (p=topnode; p; p=p->link) populatetree(p,p);
  /*}}}*/
  /* CALL to GCALL conversion */ /*{{{*/
  for (p=topnode; p; p=p->link)
  {
    int op=p->op;

    /* convert CALL[IFDV] of ADDRGP to GCALL[IFDV] if only ARG[IP] and nice depth */ /*{{{*/
    switch (op)
    {
      /* ARG[IP] */ /*{{{*/
      case ARGI:
      case ARGP:
      {
        thirdlastarg=secondlastarg;
        secondlastarg=lastarg;
        lastarg=p;
        break;
      }
      /*}}}*/
      /* CALL[IV] */ /*{{{*/
      case CALLI:
      case CALLF:
      case CALLD:
      case CALLV:
      {
        /* variables */ /*{{{*/
        int ds,dl;
        /*}}}*/

        if (p->kids[0]->op==ADDRGP && (state==NOARGSYET || state==FINEARGS))
        {
          /* compute depth of second last arg */ /*{{{*/
          if (secondlastarg)
          {
            ds=depth(secondlastarg,secondlastarg);
          } else ds=0;
          /*}}}*/
          /* compute depth of last arg */ /*{{{*/
          if (lastarg)
          {
            dl=depth(lastarg,lastarg);
          } else dl=0;
          /*}}}*/

          if (thirdlastarg ? ds<=2 && dl<=1 : (ds ? dl<=2 : (1)))
          {
            if (thirdlastarg) thirdlastarg->op=GARG+optype(thirdlastarg->op);
            if (secondlastarg) secondlastarg->op=GARG+optype(secondlastarg->op);
            if (lastarg) lastarg->op=GARG+optype(lastarg->op);
            p->op=GCALL+optype(p->op);
            p->syms[0]=p->kids[0]->syms[0];
            p->kids[0]->count--;
            p->kids[0]=(Node)0;
          }
        }
        thirdlastarg=(Node)0; secondlastarg=(Node)0; lastarg=(Node)0; state=NOARGSYET;
        break;
      }
      /*}}}*/
    }
    /*}}}*/
    /* state machine for fine argument types */ /*{{{*/
    switch (state)
    {
      /* NOARGSYET */ /*{{{*/
      case NOARGSYET:
      {
        if (op==ARGI || op==ARGP) state=FINEARGS;
        else if (generic(op)==ARG) state=MEANARGS;
        break;
      }
      /*}}}*/
      /* FINEARGS */ /*{{{*/
      case FINEARGS:
      {
        if (op!=ARGI && op!=ARGP) state=MEANARGS;
        break;
      }
      /*}}}*/
      default: break;
    }
    /*}}}*/
  }
  /*}}}*/
  return topnode;
}
/*}}}*/
/* local         -- allocate a local variable */ /*{{{*/
void local(Symbol p)
{
  if (p->type->op==SHORT) offset=roundup(offset, 4);
  else offset=roundup(offset, p->type->align);
  p->x.name=p->name;
  p->x.offset=offset;
  p->sclass=AUTO;
#ifdef SYMDEBUG
  if (emittoken==emitasm) sym("; local", p, "\n");
#endif
  offset+=p->type->size;
}
/*}}}*/
/* progbeg       -- beginning of program */ /*{{{*/
void progbeg(int argc, char *argv[])
{
  emittoken_s=emitasm_s;
  emittoken_i=emitasm_i;
  emittoken=emitasm;
  chip=Obj_T800;
  if (argc) { argc--; argv++; }
  while (argc--)
  {
    if (!strcmp(*argv,"-T400")) chip=Obj_T400;
    else if (!strcmp(*argv,"-T414")) chip=Obj_T414;
    else if (!strcmp(*argv,"-T425")) chip=Obj_T425;
    else if (!strcmp(*argv,"-T800")) chip=Obj_T800;
    else if (!strcmp(*argv,"-T801")) chip=Obj_T801;
    else if (!strcmp(*argv,"-T805")) chip=Obj_T805;
    else if (!strcmp(*argv,"-obj"))
    {
      emittoken_s=emitobj_s;
      emittoken_i=emitobj_i;
      emittoken=emitobj;
    }
    else if (!strcmp(*argv,"-asm"))
    {
      emittoken_s=emitasm_s;
      emittoken_i=emitasm_i;
      emittoken=emitasm;
    }
    else if (!strcmp(*argv,"-wptrcheck")) wptrcheck=1;
    argv++;
  }
  (*emittoken)(chip);
  hasfpu=(chip==Obj_T800 || chip==Obj_T801 || chip==Obj_T805);
}
/*}}}*/
/* stabend       -- finalize stab output */ /*{{{*/
void stabend(cp, p, cpp, sp, stab) Coordinate *cp, **cpp; Symbol p, *sp, *stab;
{
  int i;

#ifdef SYMDEBUG
  if (emittoken==emitasm)
  {
    symname(p);
    print("\n");
    for (i=0; cpp[i]&&sp[i]; i++)
    {
      print("; %w.%d: ", cpp[i], cpp[i]->x);
      symname(sp[i]);
      print("\n");
    }
  }
#endif
}
/*}}}*/
/* stabline      -- emit line number information for source coordinate */ /*{{{*/
void stabline(cp) Coordinate *cp;
{
#ifdef SYMDEBUG
  if (emittoken==emitasm)
  {
    if (cp->file) print("; %s:", cp->file);
    print("; %d.%d:\n", cp->y, cp->x);
  }
#endif
}
/*}}}*/

